# -*- coding: UTF-8 -*-
# CCcam Info by AliAbdul
# Update CCcam Info By RAED Full HD Skin (1920x1080) 29-06-2015
# Update CCcam Info Dimitrij openPLi 19-04-2016
# Update from Lululla py3 and minor fix
# Update CCcam Info WanWizard openPLi 27-19-2023
# Update CCcam Info Lululla 06-08-2024 - pythoncodestyle py3
# Update CCcam Info Lululla 13-09-2024 - add editLine- fix major

from __future__ import print_function
from . import _
from . import CCcamPrioMaker
from . import CCcamOrganizer
from Components.ActionMap import (
    ActionMap,
    NumberActionMap,
    HelpableActionMap,
)
from Components.Console import Console
from Components.ConfigList import ConfigListScreen
from Components.Label import Label
from Components.MenuList import MenuList
from Components.MultiContent import (MultiContentEntryText, MultiContentEntryPixmapAlphaTest)  # , MultiContentEntryPixmapAlphaBlend)
from Components.ScrollLabel import ScrollLabel
from Components.Sources.StaticText import StaticText
from Components.ServiceEventTracker import ServiceEventTracker
from Components.config import (
    config,
    ConfigSubsection,
    ConfigSelection,
    ConfigText,
    ConfigInteger,
    ConfigYesNo,
    getConfigListEntry,
    ConfigNumber,
    NoSave,
)
from Plugins.Plugin import PluginDescriptor
from Screens.HelpMenu import HelpableScreen
from Screens.InfoBar import InfoBar
from Screens.LocationBox import LocationBox
from Screens.MessageBox import MessageBox
from Screens.Screen import Screen
from Screens.Setup import Setup
from Screens.VirtualKeyBoard import VirtualKeyBoard
from Tools.Directories import (
    fileExists,
    SCOPE_GUISKIN,
    # SCOPE_CURRENT_SKIN,
    resolveFilename,
    # fileReadLines,
    # fileWriteLines,
)
# from Tools.LoadPixmap import LoadPixmap
from base64 import b64encode
from enigma import (
    eListboxPythonMultiContent,
    gFont,
    loadPNG,
    getDesktop,
    RT_HALIGN_RIGHT,
    ePoint,
    eTimer,
    iPlayableService,
    iServiceInformation,
    eSize,
)
from glob import glob
from os import (listdir, remove, rename, system)
from os.path import (dirname, exists, isfile)
from skin import getSkinFactor  # parameters

# add lululla
from sys import _getframe as getframe
from errno import ENOENT
from enigma import eGetEnigmaDebugLvl
from skin import parseColor
# from twisted.internet import reactor
# from twisted.web.client import HTTPClientFactory
import sys
import base64
# from base64 import encodebytes
import requests

DEFAULT_MODULE_NAME = __name__.split(".")[-1]
forceDebug = eGetEnigmaDebugLvl() > 4


PY3 = sys.version_info[0] == 3

if PY3:
    from urllib.parse import urlparse, urlunparse
else:
    from urlparse import urlparse, urlunparse

# Compatibilità Python 2 e 3 per base64 encoding
if sys.version_info[0] == 3:
    def encodebytes(s):
        return base64.encodebytes(s.encode('utf-8')).decode('utf-8')
else:
    def encodebytes(s):
        return base64.encodestring(s.encode('utf-8')).decode('utf-8')

VERSION = "v1.9"
DATE = "13.09.2024"
plugin_path = '/usr/lib/enigma2/python/Plugins/Extensions/CCcamInfo'
CFG = "/etc/CCcam.cfg"
CFG_path = '/etc'
ecmInfoStart = None
desktop = getDesktop(0)
size = desktop.size()
width = size.width()
lock_on = loadPNG(plugin_path + "/icons/lock_on.png")
lock_off = loadPNG(plugin_path + "/icons/lock_off.png")
TOGGLE_SHOW = InfoBar.toggleShow
# png = plugin_path + "/icons/key_%s.png" % str(idx)  #remember
# png = plugin_path + "/icons/key_%s.png" % color  #remember
global Counter
Counter = 0
AuthHeaders = {
    "User-Agent": "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36",
}

sf = getSkinFactor()


def searchConfig():
    global CFG, CFG_path
    files = glob("/etc/**/CCcam.cfg", recursive=True)
    if files:
        CFG = files[0]
        CFG_path = dirname(CFG)
    print("[CCcamInfo] searchConfig CFG=%s" % CFG)


if sys.version_info >= (2, 7, 9):
    try:
        import ssl
        sslContext = ssl._create_unverified_context()
    except:
        sslContext = None


def _parse(url):
    url = url.strip()
    print("[CCcamInfo]0 url=%s" % url)
    parsed = urlparse(url)
    scheme = parsed[0]
    pathz = urlunparse(('', '') + parsed[2:])
    if pathz == "":
        pathz = "/"
    host, port = parsed[1], 80
    username = ""
    password = ""

    basicAuth = encodebytes("%s:%s" % (username, password))
    authHeader = "Basic " + basicAuth.strip()
    AuthHeaders = {"Authorization": authHeader}
    print("[CCcamInfo]1 parsed=%s scheme=%s path=%s host=%s port=%s" % (parsed, scheme, pathz, host, port))
    if '@' in host:
        username, host = host.split('@')
        if ':' in username:
            username, password = username.split(':')
            base64string = "%s:%s" % (username, password)
            base64string = b64encode(base64string.encode('utf-8')).decode()
            authHeader = "Basic " + base64string
            AuthHeaders["Authorization"] = authHeader
    if ':' in host:
        host, port = host.split(':')
        port = int(port)
    print("[CCcamInfo]2 parsed=%s scheme=%s path=%s host=%s port=%s" % (parsed, scheme, pathz, host, port))
    url = scheme + '://' + host + ':' + str(port) + pathz
    print("[CCcamInfo]1 url=%s AuthHeaders=%s" % (url, AuthHeaders))
    return url, AuthHeaders


def getPage(url, callback, errback, counter=0):
    global Counter
    errormsg = ""
    url, AuthHeaders = _parse(url)
    print("[CCcamInfo]2 url=%s" % url)
    try:
        print(f"[CCcamInfo] URL requested: {url}")
        url, auth_headers = _parse(url)
        print(f"[CCcamInfo] Parsed URL: {url}")
        if 'username' in auth_headers and 'password' in auth_headers:
            # Codifica base64 delle credenziali
            credentials = f"{auth_headers['username']}:{auth_headers['password']}"
            encoded_credentials = b64encode(credentials.encode('utf-8')).decode('utf-8')
            auth_headers['Authorization'] = f"Basic {encoded_credentials}"

        try:
            response = requests.get(url, headers=auth_headers)
            response.raise_for_status()
        except requests.exceptions.RequestException as error:
            print(f"[CCcamInfo][getPage] Error in response: {error}")
            if counter == 0:
                counter += 1
                errormsg = f"[CCcamInfo][getPage] Error in response: {error}"
                errback(errormsg)
            else:
                callback("")
                print('callback', callback)
        else:
            try:
                data = response.content.decode(encoding='UTF-8')
            except:
                data = response.content.decode(encoding='latin-1')
        callback(data)
    except TypeError as e:
        print(f"TypeError: {e}")
        raise


class HelpableNumberActionMap(NumberActionMap):
    def __init__(self, parent, context, actions, prio):
        alist = []
        adict = {}
        for (action, funchelp) in actions.items():
            alist.append((action, funchelp[1]))
            adict[action] = funchelp[0]
        NumberActionMap.__init__(self, [context], adict, prio)
        parent.helpList.append((self, context, alist))


TranslationHelper = [
    ["Current time", _("Current time")],
    ["NodeID", _("NodeID")],
    ["Uptime", _("Uptime")],
    ["Connected clients", _("Connected clients")],
    ["Active clients", _("Active clients")],
    ["Total handled client ecm's", _("Total handled client ecm's")],
    ["Total handled client emm's", _("Total handled client emm's")],
    ["Peak load (max queued requests per workerthread)", _("Peak load (max queued requests per workerthread)")],
    ["card reader", _("card reader")],
    ["no or unknown card inserted", _("no or unknown card inserted")],
    ["system:", _("system:")],
    ["caid:", _("caid:")],
    ["provider:", _("provider:")],
    ["provid:", _("provid:")],
    ["using:", _("using:")],
    ["address:", _("address:")],
    ["hops:", _("hops:")],
    ["pid:", _("pid:")],
    ["share:", _("share:")],
    ["handled", _("handled")],
    [" and", _(" and")],
    ["card", _("card")],
    ["Cardserial", _("Cardserial")],
    ["ecm time:", _("ecm time:")]]


def translateBlock(block):
    # Assumiamo che TranslationHelper sia una lista di tuple (coppie chiave-valore)
    for key, value in TranslationHelper:
        # Utilizza str.find() per verificare se la chiave è presente
        if block.find(key) != -1:
            block = block.replace(key, value)
    return block


def getConfigValue(line):
    # Divide la linea in base al primo ':'
    key, value = line.partition(":")[2], ""
    # Rimuove gli spazi bianchi iniziali e finali e i commenti
    value = key.strip().split('#', 1)[0].strip()
    return value


def notBlackListed(entry):
    try:
        with open(config.plugins.CCcamInfo.blacklist.value, "r") as f:
            blacklisted_entries = set(line.strip() for line in f)
    except IOError as e:
        # In caso di errore di lettura del file, logga l'errore e considera tutti gli entry come non blacklisted
        print(f"Error reading blacklist file: {e}")
        blacklisted_entries = set()
    return entry not in blacklisted_entries


menu_list = [
    _("CCcam.cfg Basic Line Editor"),
    _("General"),
    _("Clients"),
    _("Active clients"),
    _("Servers"),
    _("Shares"),
    _("Share View"),
    _("Extended Shares"),
    _("Providers"),
    _("Entitlements"),
    _("ecm.info"),
    _("Menu config"),
    _("Local box"),
    _("Remote box"),
    _("CCcam Prio Maker"),
    _("CCcam Organizer"),
    _("Free memory"),
    _("Switch config"),
    _("About")]


if exists(resolveFilename(SCOPE_GUISKIN, "icons/lock_on.png")):
    lock_on = loadPNG(resolveFilename(SCOPE_GUISKIN, "icons/lock_on.png"))
else:
    lock_on = loadPNG("/usr/share/enigma2/skin_default/icons/lock_on.png")

if exists(resolveFilename(SCOPE_GUISKIN, "icons/lock_off.png")):
    lock_off = loadPNG(resolveFilename(SCOPE_GUISKIN, "icons/lock_off.png"))
else:
    lock_off = loadPNG("/usr/share/enigma2/skin_default/icons/lock_off.png")


config.cccamlineedit = ConfigSubsection()
config.cccamlineedit.protocol = NoSave(ConfigSelection(default="C:", choices=[("C:", _("CCcam")), ("N:", _("NewCamd"))]))
config.cccamlineedit.domain = NoSave(ConfigText(fixed_size=False))
config.cccamlineedit.port = NoSave(ConfigNumber())
config.cccamlineedit.username = NoSave(ConfigText(fixed_size=False))
config.cccamlineedit.password = NoSave(ConfigText(fixed_size=False))
config.cccamlineedit.deskey = NoSave(ConfigNumber())

config.plugins.CCcamInfo = ConfigSubsection()
config.plugins.CCcamInfo.name = ConfigText(default="Profile", fixed_size=False)
config.plugins.CCcamInfo.ip = ConfigText(default="192.168.1.78", fixed_size=False)
config.plugins.CCcamInfo.username = ConfigText(default="", fixed_size=False)
config.plugins.CCcamInfo.password = ConfigText(default="", fixed_size=False)
config.plugins.CCcamInfo.port = ConfigInteger(default=16001, limits=(1, 65535))
config.plugins.CCcamInfo.profile = ConfigText(default="", fixed_size=False)
config.plugins.CCcamInfo.ecmInfoEnabled = ConfigYesNo(default=True)
config.plugins.CCcamInfo.ecmInfoMainMenu = ConfigYesNo(default=True)
config.plugins.CCcamInfo.showExtMenu = ConfigYesNo(default=True)
config.plugins.CCcamInfo.ecmInfoTime = ConfigInteger(default=5, limits=(1, 60))
config.plugins.CCcamInfo.ecmInfoForceHide = ConfigYesNo(default=True)
config.plugins.CCcamInfo.serverNameLength = ConfigInteger(default=22, limits=(10, 100))
config.plugins.CCcamInfo.ecmInfoPositionX = ConfigInteger(default=50)
config.plugins.CCcamInfo.ecmInfoPositionY = ConfigInteger(default=50)
config.plugins.CCcamInfo.show_cryptoinfo = ConfigYesNo(default=True)
config.plugins.CCcamInfo.ecmInfoPositionZ = ConfigSelection([(str(x), str(x)) for x in range(-20, 21)], "10")
config.plugins.CCcamInfo.blacklist = ConfigText(default="/etc/enigma2/CCcamInfo.blacklisted", fixed_size=False)
config.plugins.CCcamInfo.profiles = ConfigText(default="/etc/enigma2/CCcamInfo.profiles", fixed_size=False)


def getConfigNameAndContent(fileName):
    try:
        with open(fileName, "r") as f:
            content = f.read()
    except IOError:  # Gestire in modo specifico gli errori di I/O
        content = ""
    if content.startswith("#CONFIGFILE NAME="):
        content = content.replace("\r", "\n")  # Gestione delle nuove righe
        name = content[17:]
        idx = name.find("\n")  # Usa find() invece di index() per evitare eccezioni
        if idx != -1:
            name = name[:idx]
    else:
        name = fileName.replace("/etc/", "")  # Rimuovi "/etc/" dal percorso del file

    return name, content


if width > 1280:
    MAX_X = 400
    MAX_Y = 62
    ORIGMAX_X = 1920
    ECMINFO_SKIN_NEW = """
        <screen position="0,0" size="1920,62" flags="wfNoBorder" zPosition="%s">
            <widget name="irdeto" position="0,0" size="30,30" font="Regular; 30" text="I" valign="center" halign="center" transparent="1" />
            <widget name="seca" position="30,0" size="30,30" font="Regular; 30" text="S" valign="center" halign="center" transparent="1" />
            <widget name="nagra" position="60,0" size="30,30" font="Regular; 30" text="N" valign="center" halign="center" transparent="1" />
            <widget name="via" position="90,0" size="30,30" font="Regular; 30" text="V" valign="center" halign="center" transparent="1" />
            <widget name="conax" position="120,0" size="45,30" font="Regular; 30" text="CO" valign="center" halign="center" transparent="1" />
            <widget name="betacrypt" position="165,0" size="40,31" font="Regular; 30" text="BC" valign="center" halign="center" transparent="1" />
            <widget name="crypto" position="207,0" size="45,30" font="Regular; 30" text="CW" valign="center" halign="center" transparent="1" />
            <widget name="dreamcrypt" position="253,0" size="45,30" font="Regular; 30" text="DC" valign="center" halign="center" transparent="1" />
            <widget name="nds" position="300,0" size="90,30" font="Regular; 30" text="NDS" valign="center" halign="center" transparent="1" />
            <widget name="drecrypt" position="0,32" size="30,30" font="Regular; 30" text="D" valign="center" halign="center" transparent="1" />
            <widget name="powervu" position="30,32" size="30,30" font="Regular; 30" text="P" valign="center" halign="center" transparent="1" />
            <widget name="verimatrix" position="60,32" size="60,30" font="Regular; 30" text="VM" valign="center" halign="center" transparent="1" />
            <widget name="rosscrypt" position="120,32" size="30,30" font="Regular; 30" text="R" valign="center" halign="center" transparent="1" />
            <widget name="exset" position="152,32" size="45,30" font="Regular; 30" text="ES" valign="center" halign="center" transparent="1" />
            <widget name="codicrypt" position="200,32" size="45,30" font="Regular; 30" text="C" valign="center" halign="center" transparent="1" />
            <widget name="digicipher" position="247,32" size="45,30" font="Regular; 30" text="DI" valign="center" halign="center" transparent="1" />
            <widget name="biss" position="295,32" size="100,30" font="Regular; 30" text="BISS" valign="center" halign="center" transparent="1" />
            <widget name="ecmInfo" position="400,15" size="1500,37" font="Regular; 35" valign="center" transparent="1" noWrap="1" />
        </screen>""" % config.plugins.CCcamInfo.ecmInfoPositionZ.value
else:
    MAX_X = 230
    MAX_Y = 34
    ORIGMAX_X = width
    ECMINFO_SKIN_NEW = """
        <screen position="0,0" size="%d,34" flags="wfNoBorder" zPosition="%s" >
            <widget name="irdeto" position="0,0" size="15,17" font="Regular;16" text="I" valign="center" halign="center" transparent="1" />
            <widget name="seca" position="15,0" size="15,17" font="Regular;16" text="S" valign="center" halign="center" transparent="1" />
            <widget name="nagra" position="30,0" size="15,17" font="Regular;16" text="N" valign="center" halign="center" transparent="1" />
            <widget name="via" position="45,0" size="15,17" font="Regular;16" text="V" valign="center" halign="center" transparent="1" />
            <widget name="conax" position="60,0" size="30,17" font="Regular;16" text="CO" valign="center" halign="center" transparent="1" />
            <widget name="betacrypt" position="90,0" size="25,17" font="Regular;16" text="BC" valign="center" halign="center" transparent="1" />
            <widget name="crypto" position="112,0" size="35,17" font="Regular;16" text="CW" valign="center" halign="center" transparent="1" />
            <widget name="dreamcrypt" position="147,0" size="25,17" font="Regular;16" text="DC" valign="center" halign="center" transparent="1" />
            <widget name="nds" position="172,0" size="45,17" font="Regular;16" text="NDS" valign="center" halign="center" transparent="1" />
            <widget name="drecrypt" position="0,16" size="15,17" font="Regular;16" text="D" valign="center" halign="center" transparent="1" />
            <widget name="powervu" position="17,16" size="15,17" font="Regular;16" text="P" valign="center" halign="center" transparent="1" />
            <widget name="verimatrix" position="34,16" size="30,17" font="Regular;16" text="VM" valign="center" halign="center" transparent="1" />
            <widget name="rosscrypt" position="66,16" size="15,17" font="Regular;16" text="R" valign="center" halign="center" transparent="1" />
            <widget name="exset" position="83,16" size="30,17" font="Regular;16" text="ES" valign="center" halign="center" transparent="1" />
            <widget name="codicrypt" position="115,16" size="15,17" font="Regular;16" text="C" valign="center" halign="center" transparent="1" />
            <widget name="digicipher" position="132,16" size="25,17" font="Regular;16" text="DI" valign="center" halign="center" transparent="1" />
            <widget name="biss" position="155,16" size="60,17" font="Regular;16" text="BISS" valign="center" halign="center" transparent="1" />
            <widget name="ecmInfo" position="230,10" size="%d,20" font="Regular;16" valign="center" transparent="1" noWrap="1" />
        </screen>""" % (width, config.plugins.CCcamInfo.ecmInfoPositionZ.value, width - 230)

SYSTEMS = ["irdeto", "seca", "nagra", "via", "conax", "betacrypt", "crypto", "dreamcrypt", "nds", "drecrypt", "powervu", "verimatrix", "rosscrypt", "exset", "codicrypt", "digicipher", "biss"]


class EcmInfoLabel(Label):
    def __init__(self, text=""):
        Label.__init__(self, text)

    def notCrypted(self):
        self.instance.setForegroundColor(parseColor("#999999"))

    def crypted(self):
        self.instance.setForegroundColor(parseColor("#ff9c00"))

    def encrypted(self):
        self.instance.setForegroundColor(parseColor("#00d100"))


class CCcamList(MenuList):
    def __init__(self, list):
        MenuList.__init__(self, list, True, eListboxPythonMultiContent)
        if width > 1280:
            self.l.setItemHeight(40)
            self.l.setFont(0, gFont("Regular", 32))
        else:
            self.l.setItemHeight(50)
            self.l.setFont(0, gFont("Regular", 28))


class CCcamShareList(MenuList):
    def __init__(self, list):
        MenuList.__init__(self, list, True, eListboxPythonMultiContent)
        if width > 1280:
            self.l.setItemHeight(110)
            self.l.setFont(0, gFont("Regular", 32))
        else:
            self.l.setItemHeight(60)
            self.l.setFont(0, gFont("Regular", 20))


class CCcamConfigList(MenuList):
    def __init__(self, list):
        MenuList.__init__(self, list, True, eListboxPythonMultiContent)
        if width > 1280:
            self.l.setItemHeight(50)
            self.l.setFont(0, gFont("Regular", 32))
        else:
            self.l.setItemHeight(40)
            self.l.setFont(0, gFont("Regular", 20))


class CCcamShareViewList(MenuList):
    def __init__(self, list):
        MenuList.__init__(self, list, True, eListboxPythonMultiContent)
        if width > 1280:
            self.l.setItemHeight(50)
            self.l.setFont(0, gFont("Regular", 32))
        else:
            self.l.setItemHeight(40)
            self.l.setFont(0, gFont("Regular", 20))


class CCcamLineEdit(Setup):
    def __init__(self, session, line):
        self.line = line
        self.extras = []
        self.deskey = "0102030405060708091011121314"
        self.domain = "address.dyndns.org"
        self.username = "username"
        self.password = "password"
        self.port = 12000
        if line == "newC":
            self.protocol = "C:"
        elif line == "newN":
            self.protocol = "N:"
        else:
            mysel = self.line.split()
            self.protocol = mysel[0]
            self.domain = mysel[1]
            self.port = int(mysel[2])
            self.username = mysel[3]
            self.password = mysel[4]
            if mysel[0] == "N:":
                # self.deskey = mysel[5] + mysel[6] + mysel[7] + mysel[8] + mysel[9] + mysel[10] + mysel[11] + mysel[12] + mysel[13] + mysel[14] + mysel[15] + mysel[16] + mysel[17] + mysel[18]
                self.deskey = "".join(mysel[5:19])
            self.extras = mysel[19:]
        config.cccamlineedit.protocol.value = self.protocol
        config.cccamlineedit.domain.value = self.domain
        config.cccamlineedit.port.value = self.port
        config.cccamlineedit.username.value = self.username
        config.cccamlineedit.password.value = self.password
        config.cccamlineedit.deskey.value = int(self.deskey)
        Setup.__init__(self, session=session, setup="CCcamLineEdit")
        self.setTitle(_("CCcam Line Editor"))
        if "new" not in self.line:
            self["key_yellow"] = StaticText(_("Remove"))
            self["cccameditactions"] = HelpableActionMap(self, ["ColorActions"], {
                "yellow": (self.keyRemove, _("Remove the Line from CCcam.cfg"))
            }, prio=1, description=_("CCcam Line Edit Actions"))

    def keySave(self):
        # TODO isChanged is always true
        if "new" in self.line or self["config"].isChanged():
            elements = [
                config.cccamlineedit.protocol.value,
                config.cccamlineedit.domain.value,
                str(config.cccamlineedit.port.value),
                config.cccamlineedit.username.value,
                config.cccamlineedit.password.value
            ]
            newline = " ".join(elements)
            if config.cccamlineedit.protocol.value == "N:":
                des = "%028d" % config.cccamlineedit.deskey.value
                des = " ".join([des[x:x + 2] for x in range(0, len(des), 2)])
                # N: 127.0.0.1 10000 dummy dummy 01 02 03 04 05 06 07 08 09 10 11 12 13 14
                # des = des[0] + des[1] + " " + des[2] + des[3] + " " + des[4] + des[5] + " " + des[6] + des[7] + " " + des[8] + des[9] + " " + des[10] + des[11] + " " + des[12] + des[13] + " " + des[14] + des[15] + " " + des[16] + des[17] + " " + des[18] + des[19] + " " + des[20] + des[21] + " " + des[22] + des[23] + " " + des[24] + des[25] + " " + des[26] + des[27]
                newline = "%s %s" % (newline, des)
                if self.extras:
                    newline = "%s %s" % (newline, " ".join(self.extras))
            lines = fileReadLines(CFG)
            if lines:
                if "new" in self.line:
                    lines = [x.strip() for x in lines]
                    # add new line at the beginning
                    lines.insert(0, newline)
                else:
                    destlines = []
                    for line in lines:
                        if line == self.line:
                            destlines.append(newline)
                        else:
                            destlines.append(line)
                    lines = destlines
                fileWriteLines(CFG, lines)
        self.close()

    def keyRemove(self):
        if "new" not in self.line:
            lines = fileReadLines(CFG)
            if lines:
                lines = [line for line in lines if line != self.line]
                fileWriteLines(CFG, lines)
        self.close()


class EcmInfoScreenNew(Screen):
    def __init__(self, session):
        Screen.__init__(self, session)
        self.session = session
        self.skin = ECMINFO_SKIN_NEW
        self.systemCaids = {"06": "irdeto",
                            "01": "seca",
                            "18": "nagra",
                            "05": "via",
                            "0B": "conax",
                            "17": "betacrypt",
                            "0D": "crypto",
                            "4A": "dreamcrypt",
                            "09": "nds",
                            "7B": "drecrypt",
                            "0E": "powervu",
                            "56": "verimatrix",
                            "A1": "rosscrypt",
                            "27": "exset",
                            "22": "codicrypt",
                            "07": "digicipher",
                            "26": "biss"}

        for x in SYSTEMS:
            self[x] = EcmInfoLabel()
        self["ecmInfo"] = Label()

        self.shown = False
        self.onShow.append(self._onShow)
        self.onHide.append(self._onHide)

        self.ecmTimer = eTimer()
        self.ecmTimer.timeout.get().append(self.parseEcmInfo)
        self.hideTimer = eTimer()
        self.hideTimer.timeout.get().append(self.hide)
        self.change = False
        self.onShow.append(self.movePosition)

    def movePosition(self):
        if self.instance:
            self.instance.move(ePoint(config.plugins.CCcamInfo.ecmInfoPositionX.value, config.plugins.CCcamInfo.ecmInfoPositionY.value))
            if not config.plugins.CCcamInfo.show_cryptoinfo.value:
                if not self.change:
                    self.change = True
                    self.instance.resize(eSize(*(MAX_X, MAX_Y)))
            elif self.change:
                self.change = False
                self.instance.resize(eSize(*(ORIGMAX_X, MAX_Y)))

    def _onShow(self):
        self.shown = True
        self.ecmTimer.start(1000, False)

    def _onHide(self):
        self.shown = False
        self.hideTimer.stop()
        self.ecmTimer.stop()

    def int2hex(self, int):
        return "%x" % int

    def refreshLabels(self):
        self.hideTimer.stop()
        self.hide()
        for x in SYSTEMS:
            self[x].notCrypted()
        self["ecmInfo"].setText("")

        service = self.session.nav.getCurrentService()
        if service:
            info = service and service.info()
            if info:
                caids = info.getInfoObject(iServiceInformation.sCAIDs)
                if caids:
                    if len(caids) > 0:
                        for caid in caids:
                            caid = self.int2hex(caid)
                            if len(caid) == 3:
                                caid = "0%s" % caid
                            caid = caid[:2]
                            caid = caid.upper()
                            if caid in self.systemCaids:
                                system = self.systemCaids.get(caid)
                                self[system].crypted()

                        self.show()
                        self.hideTimer.stop()
                        self.hideTimer.start(config.plugins.CCcamInfo.ecmInfoTime.value * 1000, True)

    def parseEcmInfoLine(self, line):
        if ":" in line:
            idx = line.index(":")
            line = line[idx + 1:].strip()  # Rimuove spazi inizio/fine e il carattere newline
            return line
        return ""

    def ecmfile(self):
        info = {}
        ecm = []
        if self.shown:
            # Lista dei file da cercare
            ecm_files = ["/tmp/ecm.info", "/tmp/ecm1.info", "/tmp/ecm0.info"]
            # Prova ad aprire i file e leggere il contenuto
            for file_path in ecm_files:
                if fileExists(file_path):
                    try:
                        with open(file_path, "r") as f:
                            ecm = f.readlines()
                        break  # Se il file è stato letto con successo, esci dal loop
                    except IOError:
                        pass  # Gestione silenziosa se non riesce ad aprire il file
            # Elaborazione del contenuto letto
            if ecm:
                for line in ecm:
                    x = line.lower().find("msec")
                    if x != -1:
                        info["ecm time"] = line[:x + 4].strip()  # ECM time fino a "msec"
                    else:
                        item = line.split(":", 1)
                        if len(item) > 1:
                            info[item[0].strip().lower()] = item[1].strip()
                        else:
                            if "caid" not in info:
                                x = line.lower().find("caid")
                                if x != -1:
                                    y = line.find(",")
                                    if y != -1:
                                        info["caid"] = line[x + 5:y].strip()
        return info

    def parseEcmInfo(self):
        textvalue = ""
        if not self.shown:
            self["ecmInfo"].setText(textvalue)
            return
        service = self.session.nav.getCurrentService()
        if not service:
            self["ecmInfo"].setText(textvalue)
            return
        info = service.info()
        if not info or not info.getInfo(iServiceInformation.sIsCrypted):
            self["ecmInfo"].setText(textvalue)
            return
        if not info.getInfoObject(iServiceInformation.sCAIDs):
            self["ecmInfo"].setText(_("No parse cannot emu"))
            return
        ecm_info = self.ecmfile()
        if not ecm_info:
            self["ecmInfo"].setText(textvalue)
            return
        # Gestione CAID
        caid = ecm_info.get("caid", "").lstrip("0x").upper().zfill(4)
        caid_display = f"Caid: {caid}"
        # Gestione del sistema basato su CAID
        if caid and caid != "0000":
            system_id = caid[:2]
            system = self.systemCaids.get(system_id)
            if system:
                self[system].encrypted()
        if not config.plugins.CCcamInfo.show_cryptoinfo.value:
            self["ecmInfo"].setText(textvalue)
            return
        # Provider Wicard
        provider = ecm_info.get("Provider", "").lstrip("0x").upper().zfill(6)
        provider_display = f"Prov: {provider}"
        # Lettura dell'ECM time
        ecm_time = ecm_info.get("ecm time", "")
        if ecm_time:
            ecm_time_display = f"Ecm: {ecm_time} s" if "msec" not in ecm_time else f"Ecm: {ecm_time}"
        # Altri valori da ECM info
        reader = ecm_info.get("reader", "")
        prov = ecm_info.get("prov", "").lstrip("0x").upper().zfill(6)
        from2 = ecm_info.get("from", "")[:config.plugins.CCcamInfo.serverNameLength.value - 3] + "***"
        address = ecm_info.get("address", "")[:config.plugins.CCcamInfo.serverNameLength.value - 3] + "***"
        protocol = ecm_info.get("protocol", "")
        using = ecm_info.get("using", "")
        source = ecm_info.get("source", "")
        oscsource = ecm_info.get("reader", "")
        wicarddsource = ecm_info.get("response time", "")
        decode = ecm_info.get("decode", "")
        # Costruzione del testo basato su "using"
        if using:
            if using == "emu":
                textvalue = f"(EMU) {caid_display} - {ecm_time_display}"
            elif using == "CCcam-s2s":
                textvalue = f"(NET) {caid_display} - {address} - {using} - {ecm_time_display}"
            else:
                textvalue = f"{caid_display} - {address} - {using} - {ecm_time_display}"
        else:
            # Costruzione del testo per vari sorgenti
            if source:
                source_truncated = source[:config.plugins.CCcamInfo.serverNameLength.value - 3] + "***"
                if source == "emu":
                    textvalue = f"Source: EMU {caid_display}"
                else:
                    textvalue = f"{caid_display} Prov: {prov} - {source_truncated} - {ecm_time_display}"
            elif oscsource:
                if oscsource == "emu":
                    textvalue = f"Source: EMU {caid_display}"
                else:
                    textvalue = f"Reader: {reader} ( {caid_display} Prov: {prov} - {from2} - {ecm_time_display} - {protocol} )"
            elif wicarddsource:
                wicarddsource_truncated = wicarddsource[:config.plugins.CCcamInfo.serverNameLength.value - 3] + "***"
                textvalue = f"{caid_display} - {provider_display} - {wicarddsource_truncated}"
            elif decode:
                decode_truncated = decode[:config.plugins.CCcamInfo.serverNameLength.value - 3] + "***"
                textvalue = f"{caid_display} - {decode_truncated}"
        self["ecmInfo"].setText(textvalue)

    def parseEcmInfo1(self):
        if not self.shown:
            return
        ecmInfoString = []
        address = ""
        hops = ""
        ecmTime = ""
        try:
            with open("/tmp/ecm.info", "r") as f:
                content = f.read()
        except FileNotFoundError:
            try:
                with open("/tmp/ecm1.info", "r") as f:
                    content = f.read()
            except FileNotFoundError:
                self["ecmInfo"].setText(_("No ECM info available"))
                return

        contentInfo = content.split("\n")
        for line in contentInfo:
            if line.startswith("caid:"):
                caid = self.parseEcmInfoLine(line)
                if "x" in caid:
                    caid = caid.split("x", 1)[1].zfill(3).upper()[:2]
                    if caid in self.systemCaids:
                        system = self.systemCaids.get(caid)
                        self[system].encrypted()
            elif line.startswith("using:"):
                using = self.parseEcmInfoLine(line)
                using = _("Free to Air") if using == "fta" else using
            elif line.startswith("address:"):
                address = self.parseEcmInfoLine(line)
                if len(address) > config.plugins.CCcamInfo.serverNameLength.value:
                    address = f"{address[:config.plugins.CCcamInfo.serverNameLength.value - 3]}***"
            elif line.startswith("hops:"):
                hops = f"{_('Hops:')} {self.parseEcmInfoLine(line)}"
            elif line.startswith("ecm time:"):
                ecmTime = f"{_('Ecm time:')} {self.parseEcmInfoLine(line)}"
        if using:
            ecmInfoString.append(using)
        if address:
            ecmInfoString.append(address)
        if hops:
            ecmInfoString.append(hops)
        if ecmTime:
            ecmInfoString.append(ecmTime)

        self["ecmInfo"].setText(" ".join(ecmInfoString))


class EcmInfo:
    def __init__(self):
        self.dialog = None
        self.mayShow = True
        self.hideCallbackAdded = False
        self.__event_tracker = None  # Aggiunto per tracciare il tracker come attributo della classe

    def gotSession(self, session):
        if not self.dialog and session:
            self.dialog = session.instantiateDialog(EcmInfoScreenNew)
            InfoBar.toggleShow = self.toggleShow
        if not self.__event_tracker:  # Tracciare solo una volta
            self.__event_tracker = ServiceEventTracker(
                screen=self.dialog,
                eventmap={
                    iPlayableService.evUpdatedInfo: self.evUpdatedInfo,
                    iPlayableService.evEnd: self.__evEnd
                }
            )

    def evUpdatedInfo(self):
        if config.plugins.CCcamInfo.ecmInfoEnabled.value and self.mayShow:
            self.dialog.refreshLabels()

    def __evEnd(self):
        if self.dialog and self.dialog.shown:  # Verifica che il dialogo sia attualmente mostrato
            self.dialog.hide()

    def toggleShow(self):
        self.evUpdatedInfo()
        if InfoBar and InfoBar.instance:
            TOGGLE_SHOW(InfoBar.instance)
            if not self.hideCallbackAdded:
                self.hideCallbackAdded = True
                InfoBar.instance.onHide.append(self._onHide)

    def _onHide(self):
        if config.plugins.CCcamInfo.ecmInfoForceHide.value and self.dialog.shown:  # Verifica che sia visibile prima di nasconderlo
            self.dialog.hide()


# Creazione di un'istanza di EcmInfo
ecmInfo = EcmInfo()


class EcmInfoPositioner(Screen):
    def __init__(self, session):
        Screen.__init__(self, session)
        self.session = session
        self.skin = ECMINFO_SKIN_NEW

        for x in SYSTEMS:
            self[x] = EcmInfoLabel()
        self["ecmInfo"] = Label("")

        self["actions"] = ActionMap(["CCcamInfoActions"],
                                    {"left": self.left,
                                     "up": self.up,
                                     "right": self.right,
                                     "down": self.down,
                                     "ok": self.ok,
                                     "cancel": self.exit}, -1)

        self.moveTimer = eTimer()
        self.moveTimer.timeout.get().append(self.movePosition)
        self.moveTimer.start(50, 1)

    def createLabels(self):
        for x in SYSTEMS:
            self[x].notCrypted()

    def movePosition(self):
        self.instance.move(ePoint(config.plugins.CCcamInfo.ecmInfoPositionX.value, config.plugins.CCcamInfo.ecmInfoPositionY.value))
        self.moveTimer.start(50, 1)

    def left(self):
        value = config.plugins.CCcamInfo.ecmInfoPositionX.value
        value -= 1
        if value < 0:
            value = 0
        config.plugins.CCcamInfo.ecmInfoPositionX.value = value

    def up(self):
        value = config.plugins.CCcamInfo.ecmInfoPositionY.value
        value -= 1
        if value < 0:
            value = 0
        config.plugins.CCcamInfo.ecmInfoPositionY.value = value

    def right(self):
        value = config.plugins.CCcamInfo.ecmInfoPositionX.value
        value += 1
        config.plugins.CCcamInfo.ecmInfoPositionX.value = value

    def down(self):
        value = config.plugins.CCcamInfo.ecmInfoPositionY.value
        value += 1
        config.plugins.CCcamInfo.ecmInfoPositionY.value = value

    def ok(self):
        config.plugins.CCcamInfo.ecmInfoPositionX.save()
        config.plugins.CCcamInfo.ecmInfoPositionY.save()
        self.close()

    def exit(self):
        config.plugins.CCcamInfo.ecmInfoPositionX.cancel()
        config.plugins.CCcamInfo.ecmInfoPositionY.cancel()
        self.close()


if width > 1280:
    EcmInfoConfigMenu_SKIN = """
    <screen name="" position="center,center" size="860,320" title="CCcam Info">
        <widget name="config" position="10,10" size="840,300" scrollbarMode="showOnDemand" font="Regular; 25" />
    </screen>"""
else:
    EcmInfoConfigMenu_SKIN = """
    <screen position="center,center" size="560,220" title="CCcam Info">
        <widget name="config" position="10,10" size="540,200" scrollbarMode="showOnDemand" />
    </screen>"""


class EcmInfoConfigMenu(ConfigListScreen, Screen):

    def __init__(self, session):
        Screen.__init__(self, session)
        self.session = session
        self.skin = EcmInfoConfigMenu_SKIN
        self.setTitle(_("Encoding screen config menu"))
        self.positionEntry = ConfigSelection(choices=["<>"], default="<>")
        ConfigListScreen.__init__(self, [
            getConfigListEntry(_("Activate screen:"), config.plugins.CCcamInfo.ecmInfoEnabled),
            getConfigListEntry(_("Show ecm.info:"), config.plugins.CCcamInfo.show_cryptoinfo),
            getConfigListEntry(_("Hide ecm.info after (x) seconds:"), config.plugins.CCcamInfo.ecmInfoTime),
            getConfigListEntry(_("Hide ecm.info with InfoBar:"), config.plugins.CCcamInfo.ecmInfoForceHide),
            getConfigListEntry(_("Cut servername after (x) letters:"), config.plugins.CCcamInfo.serverNameLength),
            getConfigListEntry(_("Z position screen:"), config.plugins.CCcamInfo.ecmInfoPositionZ),
            getConfigListEntry("X / Y " + _("Position:"), self.positionEntry),
            getConfigListEntry(_("Show CCcam Info in ext menu:"), config.plugins.CCcamInfo.showExtMenu)])

        self["actions"] = ActionMap(["CCcamInfoActions"], {"ok": self.okClicked, "cancel": self.exit}, -2)

    def keyLeft(self):
        ConfigListScreen.keyLeft(self)
        self.handleKeysLeftAndRight()

    def keyRight(self):
        ConfigListScreen.keyRight(self)
        self.handleKeysLeftAndRight()

    def handleKeysLeftAndRight(self):
        sel = self["config"].getCurrent()[1]
        if sel == self.positionEntry:
            self.checkEcmInfoSession()
            self.session.openWithCallback(self.ecmInfoPositionerCallback, EcmInfoPositioner)

    def ecmInfoPositionerCallback(self, callback=None):
        ecmInfo.mayShow = True

    def checkEcmInfoSession(self):
        if ecmInfo.dialog is None:
            ecmInfo.gotSession(self.session)
        ecmInfo.mayShow = False
        ecmInfo.dialog.hide()

    def okClicked(self):
        for x in self["config"].list:
            x[1].save()
        self.close()

    def exit(self):
        for x in self["config"].list:
            x[1].cancel()
        self.close()


def CCcamListEntry(name, idx):
    res = [(name)]
    if idx == 10:
        idx = "red"
    elif idx == 11:
        idx = "green"
    elif idx == 12:
        idx = "yellow"
    elif idx == 13:
        idx = "blue"
    elif idx == 14:
        idx = "menu"
    elif idx == 15:
        idx = "info"

    png = plugin_path + "/icons/key_%s.png" % str(idx)

    if fileExists(png):
        res.append(MultiContentEntryPixmapAlphaTest(pos=(5, 9), size=(35, 25), png=loadPNG(png)))
    res.append(MultiContentEntryText(pos=(50, 3), size=(500, 40), font=0, text=name))
    return res


def CCcamServerListEntry(name, color):
    res = [(name)]
    png = plugin_path + "/icons/key_%s.png" % color
    if fileExists(png):
        res.append(MultiContentEntryPixmapAlphaTest(pos=(5, 9), size=(35, 25), png=loadPNG(png)))
    res.append(MultiContentEntryText(pos=(50, 3), size=(500, 40), font=0, text=name))
    return res


def CCcamShareListEntry(hostname, type, caid, system, uphops, maxdown):
    res = [(hostname, type, caid, system, uphops, maxdown)]
    res.append(MultiContentEntryText(pos=(5, 5), size=(380, 35), font=0, text=hostname))
    res.append(MultiContentEntryText(pos=(450, 5), size=(300, 35), font=0, text=_("Type: ") + type, flags=RT_HALIGN_RIGHT))
    res.append(MultiContentEntryText(pos=(5, 35), size=(380, 35), font=0, text=_("CaID: ") + caid))
    res.append(MultiContentEntryText(pos=(450, 35), size=(300, 35), font=0, text=_("System: ") + system, flags=RT_HALIGN_RIGHT))
    res.append(MultiContentEntryText(pos=(5, 70), size=(380, 35), font=0, text=_("Uphops: ") + uphops))
    res.append(MultiContentEntryText(pos=(450, 70), size=(300, 35), font=0, text=_("Maxdown: ") + maxdown, flags=RT_HALIGN_RIGHT))
    return res


def CCcamShareViewListEntry(caidprovider, providername, numberofcards, numberofreshare):
    res = [(caidprovider, providername, numberofcards)]
    res.append(MultiContentEntryText(pos=(5, 5), size=(420, 40), font=0, text=providername))
    res.append(MultiContentEntryText(pos=(430, 5), size=(50, 40), font=0, text=numberofcards, flags=RT_HALIGN_RIGHT))
    res.append(MultiContentEntryText(pos=(480, 5), size=(50, 40), font=0, text=numberofreshare, flags=RT_HALIGN_RIGHT))
    return res


def CCcamConfigListEntry(file):
    res = [(file)]
    try:
        with open(CFG, "r") as f:
            org = f.read()
        # Verifica se il contenuto letto è in bytes (per Python 2)
        if isinstance(org, bytes):
            org = org.decode("utf-8")  # Decodifica per Python 2
    except (IOError, OSError) as e:
        print(str(e))
        org = ""
    (name, content) = getConfigNameAndContent(file)

    if content == org:
        png = lock_on
    else:
        png = lock_off

    res.append(MultiContentEntryPixmapAlphaTest(pos=(5, 9), size=(35, 25), png=png))
    res.append(MultiContentEntryText(pos=(40, 2), size=(550, 40), font=0, text=name))

    return res


def CCcamMenuConfigListEntry(name, blacklisted):
    res = [(name)]

    if blacklisted:
        png = lock_off
    else:
        png = lock_on

    res.append(MultiContentEntryPixmapAlphaTest(pos=(5, 9), size=(35, 25), png=png))
    res.append(MultiContentEntryText(pos=(40, 2), size=(550, 40), font=0, text=name))

    return res


if width > 1280:
    CCcamInfoMain_SKIN = """
    <screen position="center,center" size="800,620" title="CCcam Info">
        <widget name="menu" position="0,0" size="800,620" scrollbarMode="showOnDemand" />
    </screen>"""
else:
    CCcamInfoMain_SKIN = """
    <screen position="center,center" size="500,420" title="CCcam Info" >
        <widget name="menu" position="0,0" size="500,420" scrollbarMode="showOnDemand" />
    </screen>"""


class CCcamInfoMain(Screen):

    def __init__(self, session):
        Screen.__init__(self, session)
        self.session = session
        self.skin = CCcamInfoMain_SKIN
        self.setTitle(_("CCcam Info Main"))
        self["menu"] = CCcamList([])

        self.working = False
        self.Console = Console()
        if not isfile(CFG):
            print("[CCcamInfo] %s not found" % CFG)
            searchConfig()
        try:
            if config.plugins.CCcamInfo.profile.value == "":
                self.readConfig()
            else:
                self.url = config.plugins.CCcamInfo.profile.value
        except Exception as e:
            print(e)
            pass
        self["actions"] = NumberActionMap(["CCcamInfoActions"],
                                          {"1": self.keyNumberGlobal,
                                           "2": self.keyNumberGlobal,
                                           "3": self.keyNumberGlobal,
                                           "4": self.keyNumberGlobal,
                                           "5": self.keyNumberGlobal,
                                           "6": self.keyNumberGlobal,
                                           "7": self.keyNumberGlobal,
                                           "8": self.keyNumberGlobal,
                                           "9": self.keyNumberGlobal,
                                           "0": self.keyNumberGlobal,
                                           "red": self.red,
                                           "green": self.green,
                                           "yellow": self.yellow,
                                           "blue": self.blue,
                                           "menu": self.menu,
                                           "info": self.info,
                                           "ok": self.okClicked,
                                           "cancel": self.close,
                                           "up": self.up,
                                           "down": self.down,
                                           "left": self.left,
                                           "right": self.right}, -2)

        self.onLayoutFinish.append(self.updateMenuList)

    def updateMenuList(self):
        self.working = True

        self.menu_list = []
        for x in self.menu_list:
            del self.menu_list[0]
        items = []
        idx = 0
        for x in menu_list:
            if notBlackListed(x):
                items.append(CCcamListEntry(x, idx))
                self.menu_list.append(x)
                idx += 1
        self["menu"].setList(items)
        self.working = False

    def readConfig(self):
        self.url = "http://127.0.0.1:16001"
        username = None
        password = None
        try:
            # Utilizza il costrutto 'with' per garantire che il file venga chiuso correttamente
            with open(CFG, 'r') as f:
                for lx in f:
                    lx = lx.strip()  # Rimuove eventuali spazi bianchi alla fine delle righe
                    if lx.startswith('WEBINFO LISTEN PORT :'):
                        port = getConfigValue(lx)
                        if port:
                            self.url = self.url.replace('16001', port)

                    elif lx.startswith('WEBINFO USERNAME :'):
                        username = getConfigValue(lx)

                    elif lx.startswith('WEBINFO PASSWORD :'):
                        password = getConfigValue(lx)
        except IOError as e:
            print(f"Errore nella lettura del file di configurazione: {e}")
            return
        # Se username e password sono presenti, aggiorna l'URL con le credenziali
        if username and password:
            parsed_url = urlparse(self.url)
            # Ricostruzione dell'URL con username e password
            netloc = f"{username}:{password}@{parsed_url.hostname}"
            if parsed_url.port:
                netloc += f":{parsed_url.port}"
            self.url = urlunparse((parsed_url.scheme, netloc, parsed_url.path, '', '', ''))
        # Salva il profilo vuoto in config
        config.plugins.CCcamInfo.profile.value = ""
        config.plugins.CCcamInfo.profile.save()

    def profileSelected(self, url=None):
        if url is not None:
            self.url = url
            config.plugins.CCcamInfo.profile.value = self.url
            config.plugins.CCcamInfo.profile.save()
            self.showInfo(_("New profile: ") + url)
        else:
            self.showInfo(_("Using old profile: ") + self.url)

    def keyNumberGlobal(self, idx):
        if self.working is False and (idx < len(self.menu_list)):
            self.working = True
            sel = self.menu_list[idx]
            if sel == _("General"):
                getPage(self.url, self.showCCcamGeneral, self.getWebpageError)
            elif sel == _("Clients"):
                getPage(self.url + "/clients", self.showCCcamClients, self.getWebpageError)
            elif sel == _("Active clients"):
                getPage(self.url + "/activeclients", self.showCCcamClients, self.getWebpageError)
            elif sel == _("Servers"):
                getPage(self.url + "/servers", self.showCCcamServers, self.getWebpageError)
            elif sel == _("Shares"):
                getPage(self.url + "/shares", self.showCCcamShares, self.getWebpageError)
            elif sel == _("Share View"):
                self.session.openWithCallback(self.workingFinished, CCcamShareViewMenu, self.url)
            elif sel == _("Extended Shares"):
                self.session.openWithCallback(self.workingFinished, CCcamInfoShareInfo, "None", self.url)
            elif sel == _("Providers"):
                getPage(self.url + "/providers", self.showCCcamProviders, self.getWebpageError)
            elif sel == _("Entitlements"):
                getPage(self.url + "/entitlements", self.showCCcamEntitlements, self.getWebpageError)
            elif sel == _("ecm.info"):
                self.session.openWithCallback(self.showEcmInfoFile, CCcamInfoEcmInfoSelection)
            elif sel == _("Menu config"):
                self.session.openWithCallback(self.updateMenuList, CCcamInfoMenuConfig)
            elif sel == _("Local box"):
                self.readConfig()
                self.showInfo(_("Profile: Local box"))

            elif sel == _("Remote box"):
                self.session.openWithCallback(self.profileSelected, CCcamInfoRemoteBoxMenu)
            elif sel == _("CCcam Prio Maker"):
                self.session.openWithCallback(self.workingFinished, CCcamPrioMaker.Ccprio_Setup)
            elif sel == _("CCcam Organizer"):
                self.session.openWithCallback(self.workingFinished, CCcamOrganizer.OrganizerMenu)
            elif sel == _("Free memory"):
                if not self.Console:
                    self.Console = Console()
                self.working = True
                self.Console.ePopen("free", self.showFreeMemory)
            elif sel == _("Switch config"):
                self.session.openWithCallback(self.workingFinished, CCcamInfoConfigSwitcher)
            elif sel == _("CCcam.cfg Basic Line Editor"):
                if isfile(CFG):
                    self.showCfgSelection()
                else:
                    self.showInfo(_("Could not open the file %s!") % CFG, _("Error"))
            else:
                text = _("CCcam Info %s\nby AliAbdul, modified for Python3 by WanWizard %s\n\nrecoded from Lululla") % (VERSION, DATE) + _("This plugin shows you the status of your CCcam.")
                self.showInfo(text)

    def showCfgSelection(self):
        cfgLines = []
        lines = fileReadLines(CFG)
        if lines:
            lines = [x.strip() for x in lines]
            lines = [x for x in lines if x.startswith('C:') or x.startswith('N:')]
            for line in lines:
                lineElements = line.split(" ")
                lineDescription = "%s %s %s" % (lineElements[0], lineElements[1], lineElements[2])
                cfgLines.append((lineDescription, line))
            cfgLines.append((_("Add new CCcam line"), "newC"))
            cfgLines.append((_("Add new NewCamd line"), "newN"))
            self.session.openWithCallback(self.showCfgSelectionCallback, MessageBox, _("Please select a line to edit or select add to create new line."), list=cfgLines)
            # self.session.openWithCallback(self.showCfgSelectionCallback, MessageBox, _("Please select a line to edit or select add to create new line."), list=cfgLines, windowTitle=_("CCcam - Lines"))

        else:
            self.workingFinished()

    def showCfgSelectionCallback(self, line):
        if line:
            self.session.openWithCallback(self.workingFinished, CCcamLineEdit, line)
        else:
            self.workingFinished()

    def red(self):
        self.keyNumberGlobal(10)

    def green(self):
        self.keyNumberGlobal(11)

    def yellow(self):
        self.keyNumberGlobal(12)

    def blue(self):
        self.keyNumberGlobal(13)

    def menu(self):
        self.keyNumberGlobal(14)

    def info(self):
        self.keyNumberGlobal(15)

    def okClicked(self):
        self.keyNumberGlobal(self["menu"].getSelectedIndex())

    def up(self):
        if self.working is False:
            self["menu"].up()

    def down(self):
        if self.working is False:
            self["menu"].down()

    def left(self):
        if self.working is False:
            self["menu"].pageUp()

    def right(self):
        if self.working is False:
            self["menu"].pageDown()

    def getWebpageError(self, error):
        print(str(error))
        self.session.openWithCallback(self.workingFinished, MessageBox, _("Error reading webpage!"), MessageBox.TYPE_ERROR)

    def showFile(self, file):
        try:
            with open(file, "r") as f:
                content = f.read()
            # Verifica se il contenuto è in bytes (utile per Python 2)
            if isinstance(content, bytes):
                content = content.decode("utf-8")
        except (IOError, OSError) as e:
            print(str(e))
            content = _("Could not open the file %s!") % file
        self.showInfo(translateBlock(content))

    def showEcmInfoFile(self, file=None):
        if file is not None:
            self.showFile("/tmp/" + file)
        self.workingFinished()

    def showCCcamGeneral(self, html):
        start_tag = '<BR><BR>'
        end_tag = '<BR></BODY>'

        # Verifica che html sia una stringa
        if not isinstance(html, str):
            self.showInfo(_("Invalid HTML content!"))
            return

        start_idx = html.find(start_tag)
        end_idx = html.find(end_tag)

        if start_idx != -1 and end_idx != -1:
            html_content = html[start_idx + len(start_tag):end_idx]
            html_content = html_content.replace("<BR>", "\n").strip()

        # Rimuovere righe vuote multiple
        html_content = "\n".join(line for line in html_content.split("\n") if line.strip())

        # html_content = "\n".join(line for line in html.split("\n") if line.strip())
        self.infoToShow = html_content

        # Assicurati che self.url sia una stringa
        if not isinstance(self.url, str):
            self.showInfo(_("Invalid URL!"))
            return

        # Verifica che getPage e showCCcamGeneral2 siano definiti correttamente
        try:
            # getPage(self.url + "/shares").addCallback(self.showCCcamGeneral2).addErrback(self.getWebpageError)
            getPage(self.url + "/shares", self.showCCcamGeneral2, self.getWebpageError)
        except Exception as e:
            print(str(e))
            self.showInfo(f"Error processing the page: {str(e)}")

    def showCCcamGeneral2(self, html):
        # Extract CCcam version
        version_start = "Welcome to CCcam"
        version_start_idx = html.find(version_start)
        if version_start_idx != -1:
            version_start_idx += len(version_start)
            version_end_idx = html.find(" ", version_start_idx)
            if version_end_idx != -1:
                version = html[version_start_idx:version_end_idx].strip()
                self.infoToShow = "%s%s\n%s" % (_("Version: "), version, self.infoToShow)

        # Extract available shares
        shares_start = "Available shares:"
        shares_start_idx = html.find(shares_start)

        if shares_start_idx != -1:
            shares_start_idx += len(shares_start)
            shares_end_idx = html.find("\n", shares_start_idx)
            if shares_end_idx != -1:
                shares_info = html[shares_start_idx:shares_end_idx].strip()
                self.showInfo(translateBlock("%s %s\n%s" % (_("Available shares:"), shares_info, self.infoToShow)))
            else:
                # No newline found, use the rest of the HTML
                shares_info = html[shares_start_idx:].strip()
                self.showInfo(translateBlock("%s %s\n%s" % (_("Available shares:"), shares_info, self.infoToShow)))
        else:
            # If "Available shares:" is not found, display the infoToShow
            self.showInfo(translateBlock(self.infoToShow))

    def showCCcamClients(self, html):
        first_line = True
        client_list = []
        info_list = []
        lines = html.split("\n")

        for line in lines:
            if '|' in line:
                if first_line:
                    first_line = False
                else:
                    fields = line.split('|')
                    if len(fields) > 8:
                        username = fields[1].strip()
                        if username:
                            hostname = fields[2].strip()
                            connected = fields[3].strip()
                            idle_time = fields[4].strip()
                            ecm = fields[5].strip()
                            emm = fields[6].strip()
                            version = fields[7].strip() or "N/A"
                            share = fields[8].strip()
                            ecm_emm = f"ECM: {ecm} - EMM: {emm}"
                            info_list.append([
                                username,
                                _("Hostname: ") + hostname,
                                _("Connected: ") + connected,
                                _("Idle Time: ") + idle_time,
                                _("Version: ") + version,
                                _("Last used share: ") + share,
                                ecm_emm
                            ])
                            client_list.append(username)
        self.openSubMenu(client_list, info_list)

    def showCCcamServers(self, html):
        first_line = True
        info_list = []
        lines = html.split("\n")

        for line in lines:
            if '|' in line:
                if first_line:
                    first_line = False
                else:
                    fields = line.split('|')
                    if len(fields) > 7:
                        hostname = fields[1].strip()
                        if hostname:
                            connected = fields[2].strip()
                            server_type = fields[3].strip()
                            version = fields[4].strip() or "N/A"
                            nodeid = fields[5].strip() or "N/A"
                            cards = fields[6].strip()
                            info_list.append([
                                hostname,
                                _("Cards: ") + cards,
                                _("Type: ") + server_type,
                                _("Version: ") + version,
                                _("NodeID: ") + nodeid,
                                _("Connected: ") + connected
                            ])
        self.session.openWithCallback(self.workingFinished, CCcamInfoServerMenu, info_list, self.url)

    def showCCcamShares(self, html):
        first_line = True
        shares_list = []
        info_list = []
        lines = html.split("\n")
        for line in lines:
            if '|' in line:
                if first_line:
                    first_line = False
                else:
                    fields = line.split('|')
                    if len(fields) > 7:
                        hostname = fields[1].strip()
                        if hostname:
                            share_type = fields[2].strip()
                            caid = fields[3].strip()
                            system = fields[4].strip()
                            # Elimina spazi bianchi e separa i valori di uphops e maxdown
                            share_info = fields[6].strip()
                            parts = share_info.split()
                            if len(parts) >= 2:
                                uphops = parts[0]
                                maxdown = parts[1]
                            else:
                                uphops = ""
                                maxdown = ""
                            # Aggiusta il formato di caid se necessario
                            if len(caid) == 3:
                                caid = "0" + caid
                            info_list.append([
                                hostname,
                                _("Type: ") + share_type,
                                _("CaID: ") + caid,
                                _("System: ") + system,
                                _("Uphops: ") + uphops,
                                _("Maxdown: ") + maxdown
                            ])
                            shares_list.append(f"{hostname} - {_('CaID: ')}{caid}")

        self.openSubMenu(shares_list, info_list)

    def showCCcamProviders(self, html):
        first_line = True
        providers_list = []
        info_list = []
        lines = html.split("\n")
        for line in lines:
            if '|' in line:
                if first_line:
                    first_line = False
                else:
                    fields = line.split('|')
                    if len(fields) > 5:
                        caid = fields[1].strip()
                        if caid:
                            provider = fields[2].strip()
                            provider_name = fields[3].strip()
                            system = fields[4].strip()
                            info_list.append([
                                _("CaID: ") + caid,
                                _("Provider: ") + provider,
                                _("Provider Name: ") + provider_name,
                                _("System: ") + system
                            ])
                            providers_list.append(f"{_('CaID: ')}{caid} - {_('Provider: ')}{provider}")
        self.openSubMenu(providers_list, info_list)

    def showCCcamEntitlements(self, html):
        if '<PRE>' in html:
            start_idx = html.find('<PRE>') + len('<PRE>')
            end_idx = html.find('</PRE>')
            if start_idx != -1 and end_idx != -1:
                extracted_html = html[start_idx:end_idx].replace("\n\n", "\n").strip()

                if not extracted_html:
                    extracted_html = _("No card inserted!")
                self.showInfo(translateBlock(extracted_html))
            else:
                self.showInfo(_("Error processing HTML!"))
        else:
            self.showInfo(_("Error reading webpage!"))

    def showInfo(self, info):
        self.session.openWithCallback(self.workingFinished, CCcamInfoInfoScreen, info)

    def openSubMenu(self, list, infoList):
        self.session.openWithCallback(self.workingFinished, CCcamInfoSubMenu, list, infoList)

    def workingFinished(self, callback=None):
        self.working = False

    def showFreeMemory(self, result, retval, extra_args):
        if retval == 0:
            if result.__contains__("Total:"):
                idx = result.index("Total:")
                result = result[idx + 6:]
                tmpList = result.split(" ")
                items = []
                for x in tmpList:
                    if x != "":
                        items.append(x)
                self.showInfo("%s\n\n  %s %s\n  %s %s\n  %s %s" % (_("Free memory:"), _("Total:"), items[0], _("Used:"), items[1], _("Free:"), items[2]))
            else:
                self.showInfo(result)
        else:
            self.showInfo(str(result))


if width > 1280:
    CCcamInfoEcmInfoSelection_SKIN = """
    <screen name="" position="center,center" size="800,620" title="CCcam Info">
        <widget name="list" position="0,0" size="800,620" scrollbarMode="showOnDemand" />
    </screen>"""
else:
    CCcamInfoEcmInfoSelection_SKIN = """
    <screen position="center,center" size="500,420" title="CCcam Info" >
        <widget name="list" position="0,0" size="500,420" scrollbarMode="showOnDemand" />
    </screen>"""


class CCcamInfoEcmInfoSelection(Screen):

    def __init__(self, session):
        Screen.__init__(self, session)
        self.skin = CCcamInfoEcmInfoSelection_SKIN
        self.setTitle(_("CCcam ECM Info"))
        items = []
        tmp = listdir("/tmp/")
        for x in tmp:
            if x.endswith('.info') and x.startswith('ecm'):
                items.append(x)
        self["list"] = MenuList(items)

        self["actions"] = ActionMap(["CCcamInfoActions"], {"ok": self.ok, "cancel": self.close}, -1)

    def ok(self):
        self.close(self["list"].getCurrent())


if width > 1280:
    CCcamInfoInfoScreen_SKIN = """
    <screen position="center,center" size="800,620" title="CCcam Info">
        <widget name="text" position="0,0" size="800,620" font="Regular; 30" />
    </screen>"""
else:
    CCcamInfoInfoScreen_SKIN = """
    <screen position="center,center" size="500,420" title="CCcam Info" >
        <widget name="text" position="0,0" size="500,420" font="Regular;20" />
    </screen>"""


class CCcamInfoInfoScreen(Screen):

    def __init__(self, session, info):
        Screen.__init__(self, session)
        self.skin = CCcamInfoInfoScreen_SKIN
        self.setTitle(_("CCcam Info"))
        self["text"] = ScrollLabel(info)

        self["actions"] = ActionMap(["CCcamInfoActions"],
                                    {"ok": self.close,
                                     "cancel": self.close,
                                     "up": self["text"].pageUp,
                                     "down": self["text"].pageDown,
                                     "left": self["text"].pageUp,
                                     "right": self["text"].pageDown}, -1)


if width > 1280:
    CCcamShareViewMenu_SKIN = """
    <screen position="center,center" size="860,700" title="CCcam Info">
        <widget name="list" position="0,0" size="860,565" scrollbarMode="showOnDemand" />
        <eLabel text="" position="10,567" size="840,2" font="Regular;14" backgroundColor="#ffffff" />
        <widget name="uphops" position="19,574" size="400,40" font="Regular; 30" />
        <widget name="cards" position="438,574" size="400,40" halign="right" font="Regular; 30" />
        <widget name="providers" position="19,615" size="400,40" font="Regular; 30" />
        <widget name="reshare" position="438,615" size="400,40" halign="right" font="Regular; 30" />
        <widget name="title" position="0,655" size="860,40" halign="center" font="Regular; 30" />
    </screen>"""
else:
    CCcamShareViewMenu_SKIN = """
    <screen position="center,center" size="560,430" title="CCcam Info" >
        <widget name="list" position="0,0" size="560,320" scrollbarMode="showOnDemand" />
        <eLabel text="" position="10,322" size="540,2" font="Regular;14" backgroundColor="#ffffff" />
        <widget name="uphops" position="10,340" size="260,25" font="Regular;20" />
        <widget name="cards" position="290,340" size="260,25" halign="right" font="Regular;20" />
        <widget name="providers" position="10,370" size="260,25" font="Regular;20" />
        <widget name="reshare" position="290,370" size="260,25" halign="right" font="Regular;20" />
        <widget name="title" position="0,400" size="560,20" halign="center" font="Regular;20" />
    </screen>"""


class CCcamShareViewMenu(Screen, HelpableScreen):

    def __init__(self, session, url):
        Screen.__init__(self, session)
        HelpableScreen.__init__(self)
        self.session = session
        self.skin = CCcamShareViewMenu_SKIN
        self.setTitle(_("CCcam Share View Menu"))
        self.url = url
        self.list = []
        self.providers = {}
        self.uphop = -1
        self.working = True
        self["list"] = CCcamShareViewList([])
        self["uphops"] = Label()
        self["cards"] = Label()
        self["providers"] = Label()
        self["reshare"] = Label()
        self["title"] = Label()

        self["actions"] = HelpableNumberActionMap(self, "CCcamInfoActions",
                                                  {"cancel": (self.exit, _("close share view")),
                                                   "0": (self.getUphop, _("show cards with uphop 0")),
                                                   "1": (self.getUphop, _("show cards with uphop 1")),
                                                   "2": (self.getUphop, _("show cards with uphop 2")),
                                                   "3": (self.getUphop, _("show cards with uphop 3")),
                                                   "4": (self.getUphop, _("show cards with uphop 4")),
                                                   "5": (self.getUphop, _("show cards with uphop 5")),
                                                   "6": (self.getUphop, _("show cards with uphop 6")),
                                                   "7": (self.getUphop, _("show cards with uphop 7")),
                                                   "8": (self.getUphop, _("show cards with uphop 8")),
                                                   "9": (self.getUphop, _("show cards with uphop 9")),
                                                   "green": (self.showAll, _("show all cards")),
                                                   "incUphop": (self.incUphop, _("increase uphop by 1")),
                                                   "decUphop": (self.decUphop, _("decrease uphop by 1")),
                                                   "ok": (self.getServer, _("get the cards' server"))}, -1)

        self.onLayoutFinish.append(self.getProviders)

    def exit(self):
        if self.working is False:
            self.close()

    def getProviders(self):
        getPage(self.url + "/providers", self.readProvidersCallback, self.readError)

    def readError(self, error=None):
        self.session.open(MessageBox, _("Error reading webpage!"), MessageBox.TYPE_ERROR)
        self.working = False

    def readSharesCallback(self, html):
        firstLine = True
        providerList = []
        countList = []
        shareList = []
        reshareList = []
        self.hostList = []
        self.caidList = []
        count = 0
        totalcards = 0
        totalproviders = 0
        resharecards = 0
        numberofreshare = 0
        ulevel = 0
        lines = html.split("\n")
        for line in lines:
            if '|' in line:
                if firstLine:
                    firstLine = False
                    continue
                parts = line.split('|')
                if len(parts) > 7:
                    hostname = parts[1].strip()
                    if hostname:
                        caid = parts[3].strip()
                        provider = parts[5].strip()
                        caidprovider = self.formatCaidProvider(caid, provider)
                        down = parts[6].strip()
                        if ' ' in down:
                            up, down = down.split(' ', 1)
                        else:
                            up = down
                            down = ""
                        if self.uphop == -1:
                            maxdown = down.strip()
                            numberofcards = 1
                            providername = self.providers.get(caidprovider, 'Multiple Providers given')
                            numberofreshare = 1 if int(maxdown) > 0 else 0
                            resharecards += numberofreshare
                            if caidprovider not in providerList:
                                providerList.append(caidprovider)
                                countList.append(numberofcards)
                                reshareList.append(numberofreshare)
                                shareList.append(CCcamShareViewListEntry(caidprovider, providername, str(numberofcards), str(numberofreshare)))
                                self.list.append([caidprovider, providername, numberofcards, numberofreshare])
                                totalproviders += 1
                            else:
                                index = providerList.index(caidprovider)
                                count = countList[index] + 1
                                countList[index] = count
                                numberofcards = count

                                if int(maxdown) > 0:
                                    reshareList[index] += 1
                                    numberofreshare = reshareList[index]
                                    resharecards += 1
                                else:
                                    numberofreshare = reshareList[index]
                                providername = self.providers.get(caidprovider, 'Multiple Providers given')
                                shareList[index] = CCcamShareViewListEntry(caidprovider, providername, str(numberofcards), str(numberofreshare))
                            self.hostList.append(hostname)
                            self.caidList.append(caidprovider)
                            totalcards += 1
                            ulevel = _("All")
                        else:
                            if int(up.strip()) == self.uphop:
                                providername = self.providers.get(caidprovider, 'Multiple Providers given')
                                if caidprovider not in providerList:
                                    providerList.append(caidprovider)
                                    countList.append(1)
                                    reshareList.append(1 if int(down) > 0 else 0)
                                    shareList.append(CCcamShareViewListEntry(caidprovider, providername, '1', str(reshareList[-1])))
                                    self.list.append([caidprovider, providername, '1', str(reshareList[-1])])
                                    totalproviders += 1
                                else:
                                    index = providerList.index(caidprovider)
                                    count = countList[index] + 1
                                    countList[index] = count
                                    numberofcards = count
                                    if int(down) > 0:
                                        reshareList[index] += 1
                                        numberofreshare = reshareList[index]
                                        resharecards += 1
                                    else:
                                        numberofreshare = reshareList[index]
                                    shareList[index] = CCcamShareViewListEntry(caidprovider, providername, str(numberofcards), str(numberofreshare))
                                self.hostList.append(hostname)
                                self.caidList.append(caidprovider)
                                totalcards += 1
                                ulevel = str(self.uphop)

        self.instance.setTitle(f"{_('Share View')} ({_('Total cards:')} {totalcards} {(_('Hops:'))} {ulevel})")
        self["title"].setText(f"{_('Share View')} ({_('Total cards:')} {totalcards} {(_('Hops:'))} {ulevel})")
        self["list"].setList(shareList)
        self["uphops"].setText(f"{_('Hops:')} {ulevel}")
        self["cards"].setText(f"{_('Total cards:')} {totalcards}")
        self["providers"].setText(f"{_('Providers:')} {totalproviders}")
        self["reshare"].setText(f"{_('Reshare:')} {resharecards}")
        self.working = False

    def readProvidersCallback(self, html):
        firstLine = True
        lines = html.split("\n")
        for line in lines:
            if '|' in line:
                if firstLine:
                    firstLine = False
                    continue
                parts = line.split('|')
                if len(parts) > 5:
                    caid = parts[1].strip()
                    if caid:
                        provider = parts[2].strip()
                        providername = parts[3].strip()
                        caidprovider = self.formatCaidProvider(caid, provider)
                        self.providers.setdefault(caidprovider, providername)
        # Fetch shares information
        getPage(self.url + "/shares", self.readSharesCallback, self.readError)

    def formatCaidProvider(self, caid, provider):
        pos = provider.find(",")
        if pos != -1:
            provider = provider[pos + 1:]
            pos = provider.find(",")
            if pos != -1:
                provider = provider[0:pos]

        if len(provider) == 0:
            provider = "0000"
        elif len(provider) == 1:
            provider = "000" + provider
        elif len(provider) == 2:
            provider = "00" + provider
        elif len(provider) == 3:
            provider = "0" + provider

        if len(caid) == 3:
            caid = "0" + caid

        if caid.startswith("0500") and len(provider) == 5:
            caid = "050"
        elif caid.startswith("0500") and len(provider) == 6:
            caid = "05"

        if caid.startswith("06"):
            caidprovider = caid
        elif caid.startswith("0d22"):
            caidprovider = caid
        elif caid.startswith("0d05"):
            caidprovider = caid
        elif caid.startswith("09"):
            caidprovider = caid
        elif caid.startswith("17"):
            caidprovider = caid
        elif caid.startswith("18"):
            caidprovider = caid
        elif caid.startswith("4a"):
            caidprovider = caid
        else:
            caidprovider = caid + provider
        return caidprovider

    def getUphop(self, uphop):
        self.uphop = uphop
        self.getProviders()

    def showAll(self):
        self.uphop = -1
        self.getProviders()

    def incUphop(self):
        if self.uphop < 9:
            self.uphop += 1
            self.getProviders()

    def decUphop(self):
        if self.uphop > -1:
            self.uphop -= 1
            self.getProviders()

    def getServer(self):
        server = _("Servers:") + " \n"
        sel = self["list"].getCurrent()
        if sel is not None:
            e = 0
            while e < len(self.caidList):
                if sel[0][0] == self.caidList[e]:
                    pos = self.hostList[e].find(":")
                    if pos != -1:
                        server += self.hostList[e][0:pos] + "\n"
                    else:
                        server += self.hostList[e] + "\n"
                e += 1
            self.session.open(CCcamInfoInfoScreen, server)


if width > 1280:
    CCcamInfoSubMenu_SKIN = """
    <screen position="center,center" size="800,620" title="CCcam Info">
        <widget name="list" position="0,0" size="800,330" scrollbarMode="showOnDemand" />
        <eLabel text="" position="10,332" size="780,2" font="Regular;14" backgroundColor="#ffffff" />
        <widget name="info" position="0,335" size="800,280" font="Regular; 25" transparent="1" />
    </screen>"""
else:
    CCcamInfoSubMenu_SKIN = """
    <screen position="center,center" size="500,420" title="CCcam Info" >
        <widget name="list" position="0,0" size="500,250" scrollbarMode="showOnDemand" />
        <eLabel text="" position="10,252" size="480,2" font="Regular;14" backgroundColor="#ffffff" />
        <widget name="info" position="0,255" size="500,165" font="Regular;16" transparent="1" />
    </screen>"""


class CCcamInfoSubMenu(Screen):

    def __init__(self, session, list, infoList):
        Screen.__init__(self, session)
        self.session = session
        self.skin = CCcamInfoSubMenu_SKIN
        self.setTitle(_("CCcam Info Sub Menu"))
        self.infoList = infoList
        self["list"] = MenuList(list)
        self["info"] = Label()

        self["actions"] = ActionMap(["CCcamInfoActions"], {"ok": self.okClicked, "cancel": self.close}, -1)

        self["list"].onSelectionChanged.append(self.showInfo)
        self.onLayoutFinish.append(self.showInfo)

    def okClicked(self):
        info = self.getInfo()
        if info != "":
            self.session.open(MessageBox, info, MessageBox.TYPE_INFO)

    def showInfo(self):
        info = self.getInfo()
        self["info"].setText(info)

    def getInfo(self):
        try:
            idx = self["list"].getSelectedIndex()
            info = ""
            infoList = self.infoList[idx]
            for x in infoList:
                info += x + "\n"
            return info
        except:
            return ""


if width > 1280:
    CCcamInfoServerMenu_SKIN = """
    <screen position="center,center" size="800,620" title="CCcam Info">
        <widget name="list" position="0,0" size="800,330" scrollbarMode="showOnDemand" />
        <eLabel text="" position="10,332" size="780,2" font="Regular;14" backgroundColor="#ffffff" />
        <widget name="info" position="0,335" size="800,280" font="Regular;25" transparent="1" />
    </screen>"""
else:
    CCcamInfoServerMenu_SKIN = """
    <screen position="center,center" size="500,420" title="CCcam Info" >
        <widget name="list" position="0,0" size="500,250" scrollbarMode="showOnDemand" />
        <eLabel text="" position="10,252" size="480,2" font="Regular;14" backgroundColor="#ffffff" />
        <widget name="info" position="0,255" size="500,165" font="Regular;16" transparent="1" />
    </screen>"""


class CCcamInfoServerMenu(Screen):

    def __init__(self, session, infoList, url):
        Screen.__init__(self, session)
        self.session = session
        self.skin = CCcamInfoServerMenu_SKIN
        self.setTitle(_("CCcam Info Server Menu"))
        self.infoList = infoList
        self.url = url

        items = []
        for x in self.infoList:
            if x[5].replace(_("Connected: "), "") == "":  # offline - red
                items.append(CCcamServerListEntry(x[0], "red"))
            elif x[1] == _("Cards: 0"):  # online with no card - blue
                items.append(CCcamServerListEntry(x[0], "blue"))
            else:  # online with cards - green
                items.append(CCcamServerListEntry(x[0], "green"))
        self["list"] = CCcamList(items)
        self["info"] = Label()

        self["actions"] = ActionMap(["CCcamInfoActions"], {"ok": self.okClicked, "cancel": self.close}, -1)

        self["list"].onSelectionChanged.append(self.showInfo)
        self.onLayoutFinish.append(self.showInfo)

    def showInfo(self):
        info = self.getInfo()
        self["info"].setText(info)

    def getInfo(self):
        try:
            idx = self["list"].getSelectedIndex()

            info = ""
            infoList = self.infoList[idx]
            for x in infoList:
                info += x + "\n"

            return info
        except:
            return ""

    def okClicked(self):
        sel = self["list"].getCurrent()
        if sel is not None:
            self.session.open(CCcamInfoShareInfo, sel[0], self.url)


class CCcamInfoRemoteBox:
    def __init__(self, name, ip, username, password, port):
        self.name = name
        self.ip = ip
        self.username = username
        self.password = password
        self.port = port


if width > 1280:
    CCcamInfoConfigMenu_SKIN = """
    <screen position="center,center" size="700,250" title="CCcam Info">
        <widget name="config" position="0,0" size="700,250" scrollbarMode="showOnDemand" font="Regular; 25" />
    </screen>"""
else:
    CCcamInfoConfigMenu_SKIN = """
    <screen position="center,center" size="560,150" title="CCcam Info">
        <widget name="config" position="0,0" size="560,150" scrollbarMode="showOnDemand" />
    </screen>"""


class CCcamInfoConfigMenu(ConfigListScreen, Screen):

    def __init__(self, session, profile):
        Screen.__init__(self, session)
        self.skin = CCcamInfoConfigMenu_SKIN
        self.setTitle(_("CCcam Info Config Menu"))
        config.plugins.CCcamInfo.name.value = profile.name
        config.plugins.CCcamInfo.ip.value = profile.ip
        config.plugins.CCcamInfo.username.value = profile.username
        config.plugins.CCcamInfo.password.value = profile.password
        config.plugins.CCcamInfo.port.value = profile.port

        ConfigListScreen.__init__(self, [
            getConfigListEntry(_("Name:"), config.plugins.CCcamInfo.name),
            getConfigListEntry(_("IP:"), config.plugins.CCcamInfo.ip),
            getConfigListEntry(_("Username:"), config.plugins.CCcamInfo.username),
            getConfigListEntry(_("Password:"), config.plugins.CCcamInfo.password),
            getConfigListEntry(_("Port:"), config.plugins.CCcamInfo.port)])

        self["actions"] = ActionMap(["CCcamInfoActions"], {"ok": self.okClicked, "cancel": self.exit}, -2)

    def okClicked(self):
        self.close(CCcamInfoRemoteBox(config.plugins.CCcamInfo.name.value, config.plugins.CCcamInfo.ip.value, config.plugins.CCcamInfo.username.value, config.plugins.CCcamInfo.password.value, config.plugins.CCcamInfo.port.value))

    def exit(self):
        self.close(None)


if width > 1280:
    CCcamInfoRemoteBoxMenu_SKIN = """
    <screen position="center,center" size="860,620" title="CCcam Info">
        <ePixmap pixmap="skin_default/buttons/red.png" position="20,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/green.png" position="235,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/yellow.png" position="445,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/blue.png" position="655,0" size="180,40" transparent="1" alphatest="on" />
        <widget name="key_red" position="20,0" zPosition="1" size="180,40" font="Regular; 30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_green" position="235,0" zPosition="1" size="180,40" font="Regular; 30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_yellow" position="445,0" zPosition="1" size="180,40" font="Regular; 30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_blue" position="655,0" zPosition="1" size="180,40" font="Regular; 30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="list" position="0,50" size="860,565" scrollbarMode="showOnDemand" />
    </screen>"""
else:
    CCcamInfoRemoteBoxMenu_SKIN = """
    <screen position="center,center" size="560,420" title="CCcam Info" >
        <ePixmap pixmap="skin_default/buttons/red.png" position="0,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/green.png" position="140,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/yellow.png" position="280,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/blue.png" position="420,0" size="140,40" transparent="1" alphatest="on" />
        <widget name="key_red" position="0,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_green" position="140,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_yellow" position="280,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_blue" position="420,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="list" position="0,50" size="560,360" scrollbarMode="showOnDemand" />
    </screen>"""


class CCcamInfoRemoteBoxMenu(Screen):

    def __init__(self, session):
        Screen.__init__(self, session)
        self.session = session
        self.skin = CCcamInfoRemoteBoxMenu_SKIN
        self.setTitle(_("CCcam Info Remote Box Menu"))
        self.list = []
        self.profiles = []
        self["key_red"] = Label(_("Delete"))
        self["key_green"] = Label(_("New"))
        self["key_yellow"] = Label(_("Location"))
        self["key_blue"] = Label(_("Edit"))
        self["list"] = MenuList([])
        self["actions"] = ActionMap(["CCcamInfoActions"],
                                    {"cancel": self.exit,
                                     "ok": self.profileSelected,
                                     "red": self.delete,
                                     "green": self.new,
                                     "yellow": self.location,
                                     "blue": self.edit}, -1)

        self.onLayoutFinish.append(self.readProfiles)

    def readProfiles(self):
        self.list = []  # Ensure the list is initialized
        self.profiles = []  # Ensure the profiles list is initialized
        try:
            with open(config.plugins.CCcamInfo.profiles.value, "r") as f:
                content = f.read()
        except IOError as e:
            # Log the error or handle it appropriately
            print(f"Error reading profiles file: {e}")
            content = ""
        profiles = content.split("\n")
        for profile in profiles:
            if "|" in profile:
                tmp = profile.split("|")
                if len(tmp) == 5:
                    name = tmp[0].strip()
                    ip = tmp[1].strip()
                    username = tmp[2].strip()
                    password = tmp[3].strip()
                    try:
                        port = int(tmp[4].strip())
                        if 1 <= port <= 65535:  # Ensure port is in a valid range
                            self.list.append(name)
                            self.profiles.append(CCcamInfoRemoteBox(name, ip, username, password, port))
                        else:
                            print(f"Invalid port number {port} in profile: {name}")
                    except ValueError:
                        print(f"Invalid port number format in profile: {name}")
        self["list"].setList(self.list)

    def saveConfigs(self):
        content = ""
        for x in self.profiles:
            content += f"{x.name}|{x.ip}|{x.username}|{x.password}|{x.port}\n"
        try:
            with open(config.plugins.CCcamInfo.profiles.value, "w") as f:
                f.write(content.strip())  # Strip to remove any leading/trailing newlines
        except IOError as e:
            self.session.open(MessageBox, _("Could not save the config file! Error: %s") % str(e), MessageBox.TYPE_ERROR)

    def exit(self):
        self.saveConfigs()
        self.close(None)

    def profileSelected(self):
        self.saveConfigs()
        if len(self.list) > 0:
            idx = self["list"].getSelectionIndex()
            cur = self.profiles[idx]
            if cur.ip == "":
                url = None
            else:
                if cur.username != "" and cur.password != "":
                    url = "http://%s:%s@%s:%d" % (cur.username, cur.password, cur.ip, cur.port)
                else:
                    url = "http://%s:%d" % (cur.ip, cur.port)
            self.close(url)

    def delete(self):
        if len(self.list) > 0:
            idx = self["list"].getSelectionIndex()
            del self.list[idx]
            del self.profiles[idx]
            self["list"].setList(self.list)

    def new(self):
        self.session.openWithCallback(self.newCallback, CCcamInfoConfigMenu, CCcamInfoRemoteBox("Profile", "192.168.2.12", "", "", 16001))

    def newCallback(self, callback):
        if callback:
            self.list.append(callback.name)
            self.profiles.append(callback)
            self["list"].setList(self.list)

    def location(self):
        self.session.openWithCallback(self.locationCallback, LocationBox)

    def locationCallback(self, callback):
        if callback:
            config.plugins.CCcamInfo.profiles.value = ("%s/CCcamInfo.profiles" % callback).replace("//", "/")
            config.plugins.CCcamInfo.profiles.save()
        del self.list
        self.list = []
        del self.profiles
        self.profiles = []
        self.readProfiles()

    def edit(self):
        if len(self.list) > 0:
            idx = self["list"].getSelectionIndex()
            self.session.openWithCallback(self.editCallback, CCcamInfoConfigMenu, self.profiles[idx])

    def editCallback(self, callback):
        if callback:
            idx = self["list"].getSelectionIndex()
            del self.list[idx]
            del self.profiles[idx]
            self.list.append(callback.name)
            self.profiles.append(callback)
            self["list"].setList(self.list)


if width > 1280:
    CCcamInfoShareInfo_SKIN = """
    <screen position="center,center" size="860,620" title="CCcam Info">
        <ePixmap pixmap="skin_default/buttons/red.png" position="20,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/green.png" position="235,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/yellow.png" position="445,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/blue.png" position="655,0" size="180,40" transparent="1" alphatest="on" />
        <widget name="key_red" position="20,0" zPosition="1" size="180,40" font="Regular;30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_green" position="235,0" zPosition="1" size="180,40" font="Regular;30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_yellow" position="445,0" zPosition="1" size="180,40" font="Regular;30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_blue" position="655,0" zPosition="1" size="180,40" font="Regular;30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="list" position="0,50" size="860,565" scrollbarMode="showOnDemand" />
    </screen>"""
else:
    CCcamInfoShareInfo_SKIN = """
    <screen position="center,center" size="560,420" title="CCcam Info" >
        <ePixmap pixmap="skin_default/buttons/red.png" position="0,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/green.png" position="140,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/yellow.png" position="280,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/blue.png" position="420,0" size="140,40" transparent="1" alphatest="on" />
        <widget name="key_red" position="0,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_green" position="140,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_yellow" position="280,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_blue" position="420,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="list" position="0,50" size="560,360" scrollbarMode="showOnDemand" />
    </screen>"""


class CCcamInfoShareInfo(Screen):

    def __init__(self, session, hostname, url):
        Screen.__init__(self, session)
        self.session = session
        self.skin = CCcamInfoShareInfo_SKIN
        self.setTitle(_("CCcam Share Info"))
        self.hostname = hostname
        self.url = url
        self.list = []
        self.uphops = -1
        self.maxdown = -1
        self.working = True

        self["key_red"] = Label(_("Uphops +"))
        self["key_green"] = Label(_("Uphops -"))
        self["key_yellow"] = Label(_("Maxdown +"))
        self["key_blue"] = Label(_("Maxdown -"))
        self["list"] = CCcamShareList([])

        self["actions"] = ActionMap(["CCcamInfoActions"],
                                    {"cancel": self.exit,
                                     "red": self.uhopsPlus,
                                     "green": self.uhopsMinus,
                                     "yellow": self.maxdownPlus,
                                     "blue": self.maxdownMinus}, -1)

        self.onLayoutFinish.append(self.readShares)

    def exit(self):
        if self.working is False:
            self.close()

    def readShares(self):
        # getPage(self.url + "/shares").addCallback(self.readSharesCallback).addErrback(self.readSharesError)
        getPage(self.url + "/shares", self.readSharesCallback, self.readSharesError)

    def readSharesError(self, error=None):
        self.session.open(MessageBox, _("Error reading webpage!"), MessageBox.TYPE_ERROR)
        self.working = False

    def readSharesCallback(self, html):
        firstLine = True
        shareList = []
        count = 0
        lines = html.split("\n")

        for line in lines:
            if '|' in line:
                if firstLine:
                    firstLine = False
                    continue
                parts = line.split("|")
                if len(parts) > 7:
                    hostname = parts[1].strip()
                    if (self.hostname == "None" or self.hostname == hostname) and hostname:
                        type = parts[2].strip()
                        caid = parts[3].strip()
                        system = parts[4].strip()
                        # Clean up and parse the uphops and maxdown values
                        string = parts[6].strip()
                        idx = string.find(" ")
                        uphops = string[:idx].strip()
                        maxdown = string[idx + 1:].strip()
                        # Format CAID if necessary
                        if len(caid) == 3:
                            caid = "0" + caid
                        # Append data to the lists
                        shareList.append(CCcamShareListEntry(hostname, type, caid, system, uphops, maxdown))
                        self.list.append([hostname, type, caid, system, uphops, maxdown])
                        count += 1
        # Format uplinks and maxdown values for display
        textUhops = _("All") if self.uphops < 0 else str(self.uphops)
        textMaxdown = _("All") if self.maxdown < 0 else str(self.maxdown)
        # Update the instance title and list
        self.instance.setTitle(
            "%s %d (%s%s / %s%s)" % (
                _("Available shares:"), count,
                _("Uphops: "), textUhops,
                _("Maxdown: "), textMaxdown
            )
        )
        self["list"].setList(shareList)
        self.working = False

    def uhopsPlus(self):
        if self.working is False:
            self.uphops += 1
            if self.uphops > 9:
                self.uphops = -1
            self.refreshList()

    def uhopsMinus(self):
        if self.working is False:
            self.uphops -= 1
            if self.uphops < -1:
                self.uphops = 9
            self.refreshList()

    def maxdownPlus(self):
        if self.working is False:
            self.maxdown += 1
            if self.maxdown > 9:
                self.maxdown = -1
            self.refreshList()

    def maxdownMinus(self):
        if self.working is False:
            self.maxdown -= 1
            if self.maxdown < -1:
                self.maxdown = 9
            self.refreshList()

    def refreshList(self):
        shareList = []
        count = 0
        self.working = True

        for x in self.list:
            (hostname, type, caid, system, uphops, maxdown) = x
            if (uphops == str(self.uphops) or self.uphops == -1) and (maxdown == str(self.maxdown) or self.maxdown == -1):
                shareList.append(CCcamShareListEntry(hostname, type, caid, system, uphops, maxdown))
                count += 1

        if self.uphops < 0:
            textUhops = _("All")
        else:
            textUhops = str(self.uphops)

        if self.maxdown < 0:
            textMaxdown = _("All")
        else:
            textMaxdown = str(self.maxdown)

        self.instance.setTitle("%s %d (%s%s / %s%s)" % (_("Available shares:"), count, _("Uphops: "), textUhops, _("Maxdown: "), textMaxdown))
        self["list"].setList(shareList)
        self.working = False


if width > 1280:
    CCcamInfoConfigSwitcher_SKIN = """
    <screen position="center,center" size="860,620" title="CCcam Info">
        <ePixmap pixmap="skin_default/buttons/red.png" position="20,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/green.png" position="235,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/yellow.png" position="445,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/blue.png" position="655,0" size="180,40" transparent="1" alphatest="on" />
        <widget name="key_red" position="20,0" zPosition="1" size="180,40" font="Regular;30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_green" position="235,0" zPosition="1" size="180,40" font="Regular;30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_yellow" position="445,0" zPosition="1" size="180,40" font="Regular;30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_blue" position="655,0" zPosition="1" size="180,40" font="Regular;30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="list" position="0,50" size="860,565" scrollbarMode="showOnDemand" />
    </screen>"""
else:
    CCcamInfoConfigSwitcher_SKIN = """
    <screen position="center,center" size="560,420" title="CCcam Info" >
        <ePixmap pixmap="skin_default/buttons/red.png" position="0,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/green.png" position="140,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/yellow.png" position="280,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/blue.png" position="420,0" size="140,40" transparent="1" alphatest="on" />
        <widget name="key_red" position="0,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_green" position="140,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_yellow" position="280,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_blue" position="420,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="list" position="0,50" size="560,360" scrollbarMode="showOnDemand" />
    </screen>"""


class CCcamInfoConfigSwitcher(Screen):

    def __init__(self, session):
        Screen.__init__(self, session)
        self.session = session
        self.skin = CCcamInfoConfigSwitcher_SKIN
        self.setTitle(_("CCcam Config Switcher"))
        self["key_red"] = Label(_("Delete"))
        self["key_green"] = Label(_("Activate"))
        self["key_yellow"] = Label(_("Rename"))
        self["key_blue"] = Label(_("Content"))
        self["list"] = CCcamConfigList([])

        self["actions"] = ActionMap(["CCcamInfoActions"],
                                    {"ok": self.activate,
                                     "cancel": self.close,
                                     "red": self.delete,
                                     "green": self.activate,
                                     "yellow": self.rename,
                                     "blue": self.showContent}, -1)

        self.onLayoutFinish.append(self.showConfigs)

    def showConfigs(self):
        items = []
        try:
            files = listdir(CFG_path)
        except OSError:
            files = []

        for file in files:
            if file.startswith("CCcam_") and file.endswith(".cfg"):
                items.append(CCcamConfigListEntry(CFG_path + "/" + file))
        self["list"].setList(items)

    def delete(self):
        fileName = self["list"].getCurrent()
        if fileName is not None:
            self.fileToDelete = fileName[0]
            self.session.openWithCallback(self.deleteConfirmed, MessageBox, (_("Delete %s?") % self.fileToDelete))

    def deleteConfirmed(self, yesno):
        if yesno:
            remove(self.fileToDelete)
            if fileExists(self.fileToDelete):
                self.session.open(MessageBox, _("Delete failed!"), MessageBox.TYPE_ERROR)
            else:
                self.session.open(MessageBox, _("Deleted %s!") % self.fileToDelete, MessageBox.TYPE_INFO)
                self.showConfigs()

    def activate(self):
        fileName = self["list"].getCurrent()
        if fileName is not None:
            fileName = fileName[0]
            # Delete old backup
            backupFile = "%s.backup" % CFG
            if fileExists(backupFile):
                remove(backupFile)
            # Create a backup of the original /var/etc/CCcam.cfg file
            rename(CFG, backupFile)
            # Now copy the selected cfg file
            system("cp -f %s %s" % (fileName, CFG))
            self.showConfigs()

    def rename(self):
        fileName = self["list"].getCurrent()
        if fileName is not None:
            self.fileToRename = fileName[0]
            (name, sel) = getConfigNameAndContent(self.fileToRename)
            self.session.openWithCallback(self.renameCallback, VirtualKeyBoard, title=_("Rename to:"), text=name)

    def renameCallback(self, callback):
        if callback:
            try:
                # Leggi il contenuto del file
                with open(self.fileToRename, "r") as file:
                    content = file.read()
            except IOError:
                self.session.open(MessageBox, _("Rename failed!"), MessageBox.TYPE_ERROR)
                return

            # Sostituisci i ritorni a capo e aggiorna il contenuto
            content = content.replace("\r", "\n")

            # Gestisci la riga di intestazione
            if content.startswith("#CONFIGFILE NAME=") and "\n" in content:
                idx = content.index("\n") + 1
                content = content[idx:]

            # Inserisci la nuova intestazione
            content = "#CONFIGFILE NAME=%s\n%s" % (callback, content)

            try:
                # Scrivi il contenuto aggiornato nel file
                with open(self.fileToRename, "w") as file:
                    file.write(content)
                self.session.open(MessageBox, _("Renamed %s!") % self.fileToRename, MessageBox.TYPE_INFO)
                self.showConfigs()
            except IOError:
                self.session.open(MessageBox, _("Rename failed!"), MessageBox.TYPE_ERROR)

    def showContent(self):
        fileName = self["list"].getCurrent()
        if fileName is not None and len(fileName) > 0:
            try:
                with open(fileName[0], "r") as f:
                    content = f.read()
            except IOError as e:
                # Handle file opening errors specifically
                content = _("Could not open the file %s! Error: %s") % (fileName[0], str(e))
            except Exception as e:
                # Handle other unexpected errors
                content = _("An unexpected error occurred: %s") % str(e)
            self.session.open(CCcamInfoInfoScreen, content)


if width > 1280:
    CCcamInfoMenuConfig_SKIN = """
    <screen position="center,center" size="860,620" title="CCcam Info Config">
        <ePixmap pixmap="skin_default/buttons/red.png" position="20,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/green.png" position="235,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/yellow.png" position="445,0" size="180,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/blue.png" position="655,0" size="180,40" transparent="1" alphatest="on" />
        <widget name="key_red" position="20,0" zPosition="1" size="180,40" font="Regular;30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_green" position="235,0" zPosition="1" size="180,40" font="Regular;30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_yellow" position="445,0" zPosition="1" size="180,40" font="Regular;30" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="list" position="0,50" size="860,565" scrollbarMode="showOnDemand" />
    </screen>"""
else:
    CCcamInfoMenuConfig_SKIN = """
    <screen position="center,center" size="560,420" title="CCcam Info Config" >
        <ePixmap pixmap="skin_default/buttons/red.png" position="0,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/green.png" position="140,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/yellow.png" position="280,0" size="140,40" transparent="1" alphatest="on" />
        <ePixmap pixmap="skin_default/buttons/blue.png" position="420,0" size="140,40" transparent="1" alphatest="on" />
        <widget name="key_red" position="0,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_green" position="140,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="key_yellow" position="280,0" zPosition="1" size="140,40" font="Regular;20" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
        <widget name="list" position="0,50" size="560,360" scrollbarMode="showOnDemand" />
    </screen>"""


class CCcamInfoMenuConfig(Screen):

    def __init__(self, session):
        Screen.__init__(self, session)
        self.session = session
        self.skin = CCcamInfoMenuConfig_SKIN
        self.setTitle(_("CCcam Info Config"))
        self["key_red"] = Label(_("Cancel"))
        self["key_green"] = Label(_("Save"))
        self["key_yellow"] = Label(_("Location"))
        self["list"] = CCcamConfigList([])
        self.getBlacklistedMenuEntries()

        self["actions"] = ActionMap(["CCcamInfoActions"],
                                    {"ok": self.changeState,
                                     "cancel": self.close,
                                     "red": self.close,
                                     "green": self.save,
                                     "yellow": self.location}, -1)

        self.onLayoutFinish.append(self.showConfigs)

    def getBlacklistedMenuEntries(self):
        try:
            with open(config.plugins.CCcamInfo.blacklist.value, "r") as f:
                content = f.read()
            # Gestione per Python 2 e Python 3 delle stringhe
            if isinstance(content, bytes):
                content = content.decode("utf-8")  # Decodifica per Python 2 se necessario
            self.blacklisted = content.split("\n")
        except (IOError, OSError) as e:  # Cattura errori legati ai file
            self.blacklisted = []
            print(str(e))

    def changeState(self):
        cur = self["list"].getCurrent()
        if cur is not None:
            cur = cur[0]
            if cur in self.blacklisted:
                idx = 0
                for x in self.blacklisted:
                    if x == cur:
                        del self.blacklisted[idx]
                        break
                    idx += 1
            else:
                self.blacklisted.append(cur)
        self.showConfigs()

    def showConfigs(self):
        items = []
        for x in menu_list:
            if x != _("Menu config"):
                if x in self.blacklisted:
                    items.append(CCcamMenuConfigListEntry(x, True))
                else:
                    items.append(CCcamMenuConfigListEntry(x, False))
        self["list"].setList(items)

    def save(self):
        # Join blacklisted entries with newline and ensure no double newlines
        content = "\n".join(self.blacklisted).strip() + "\n"
        try:
            with open(config.plugins.CCcamInfo.blacklist.value, "w") as f:
                f.write(content)
            self.session.open(MessageBox, _("Configfile %s saved.") % config.plugins.CCcamInfo.blacklist.value, MessageBox.TYPE_INFO)
        except IOError as e:
            # Log the error or handle it appropriately
            self.session.open(MessageBox, _("Could not save configfile %s! Error: %s") % (config.plugins.CCcamInfo.blacklist.value, str(e)), MessageBox.TYPE_ERROR)

    def location(self):
        self.session.openWithCallback(self.locationCallback, LocationBox)

    def locationCallback(self, callback):
        if callback:
            config.plugins.CCcamInfo.blacklist.value = ("%s/CCcamInfo.blacklisted" % callback).replace("//", "/")
            config.plugins.CCcamInfo.blacklist.save()


def fileReadLines(filename, default=None, source=DEFAULT_MODULE_NAME, debug=False):
    lines = None
    try:
        with open(filename) as fd:
            lines = fd.read().splitlines()
        msg = "Read"
    except OSError as err:
        if err.errno != ENOENT:  # ENOENT - No such file or directory.
            print("[%s] Error %d: Unable to read lines from file '%s'!  (%s)" % (source, err.errno, filename, err.strerror))
        lines = default
        msg = "Default"
    if debug or forceDebug:
        length = len(lines) if lines else 0
        print("[%s] Line %d: %s %d lines from file '%s'." % (source, getframe(1).f_lineno, msg, length, filename))
    return lines


def fileWriteLines(filename, lines, source=DEFAULT_MODULE_NAME, debug=False):
    try:
        with open(filename, "w") as fd:
            if isinstance(lines, list):
                lines.append("")
                lines = "\n".join(lines)
            fd.write(lines)
        msg = "Wrote"
        result = 1
    except OSError as err:
        print("[%s] Error %d: Unable to write %d lines to file '%s'!  (%s)" % (source, err.errno, len(lines), filename, err.strerror))
        msg = "Failed to write"
        result = 0
    if debug or forceDebug:
        print("[%s] Line %d: %s %d lines to file '%s'." % (source, getframe(1).f_lineno, msg, len(lines), filename))
    return result


def main(session, **kwargs):
    session.open(CCcamInfoMain)


def sessionstart(reason, **kwargs):
    global ecmInfoStart
    if reason == 0 and ecmInfoStart is None:
        CCcamPrioMaker.CCPrioMakerAutostart(kwargs["session"])
        ecmInfoStart = ecmInfo.gotSession(kwargs["session"])


def openEcmInfoConfig(session, **kwargs):
    session.open(EcmInfoConfigMenu)


def startEcmInfoConfig(menuid):
    if menuid == "system" and config.plugins.CCcamInfo.ecmInfoMainMenu.value:
        return [(_("Ecm Info"), openEcmInfoConfig, "ecm_info", None)]
    return []


def Plugins(**kwargs):
    lst = [
        PluginDescriptor(name=_("CCcam Info %s") % VERSION, description=_("This plugin shows you the status of your CCcam"), where=PluginDescriptor.WHERE_PLUGINMENU, icon="CCcamInfo.png", fnc=main),
        PluginDescriptor(where=[PluginDescriptor.WHERE_SESSIONSTART], fnc=sessionstart),
        PluginDescriptor(name="Ecm Info", where=PluginDescriptor.WHERE_MENU, fnc=startEcmInfoConfig)]
    if config.plugins.CCcamInfo.showExtMenu.value:
        lst.append(PluginDescriptor(name=_("CCcam Info %s") % VERSION, description=_("This plugin shows you the status of your CCcam"), where=PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main))
    return lst
